<?
  /* Script protection */

  if(function_exists("user_script_valid") == FALSE) {
    die(""); 
  } else {
    user_script_valid();
  }

  /*
   * La page etudiants est uniquement accessible au responsable TER 
   * Elle permet la consultation des informations etudiants, et l'ajout,
   * la modification, et la suppression de ceux ci.
   *
   * Contrairement  d'autres modules comme "perso.php", on n'aura pas
   * de fonction ici, tout se fera en linaire.
   * 1ere partie: parsing/modification;
   * 2nde partie: affichage.
   */
  global $db;
  global $error_message, $info_message;
  global $ter_location;

  /* 1ere etape: Si on a des formulaire  traiter */
  etudiants_parsing();

  if($_SERVER["REQUEST_METHOD"] == "POST") {
    if($_POST["formulaire"] && $_POST["formulaire"] == "import_csv") {
      if(isset($_FILES["myfile"]["tmp_name"])) {
        if(isset($_POST["send_mail"]) && $_POST["send_mail"] == "on")
          $envoit_mail = 1;
        else
          $envoit_mail = 0;
        $fichier = fp2txtsql($_FILES["myfile"]["tmp_name"]);
        $uf = fopen($fichier, "r");
        $err_idx = 0;
        $ok_idx = 0;
        if($uf != FALSE) {
          while(!feof($uf)) {
            $bline = fgets($uf, 4096);
            $bline = ereg_replace("\n", "", $bline);
            $bline = ereg_replace("\r", "", $bline);

            $resultat = preg_split("/;/", $bline);

            if(isset($resultat[1]) == true) {
              /* Traitement de la ligne */
              $s_nom = fp2txtsql($resultat[0]);
              $t_nom = fp2txt($resultat[0]);
              $s_prenom = fp2txtsql($resultat[1]);
              $t_prenom = fp2txt($resultat[1]);

              if(isset($resultat[2]) && $resultat[2] != "") {
                if(preg_match('/@/', $resultat[2]) == false) {
                  $s_login = fp2txtsql($resultat[2]);
                  $s_email = $s_login."@cict.fr";
                } else {
                  $s_email = fp2txtsql($resultat[2]);
                }
              } else {
                $s_email = "";
              }

              if(isset($resultat[3])) {
                $s_login = fp2txtsql($resultat[3]);
              } else
                $s_login = "";

              if(isset($resultat[4])) {
                $s_password = fp2txtsql($resultat[4]);
                if(strlen($s_password) < 4) {
                  unset($s_password);
                }
              } else
                $s_password = "";

              /* Formatage prnom ... */
              $s_nom_final = strtoupper($s_nom);
              $s_prenom_final = strtoupper($s_prenom[0]);
              $s_prenom_final.= substr(strtolower($s_prenom), 1, strlen($s_prenom) - 1);

              $s_description = $s_nom_final . " " . $s_prenom_final;

              $t_nom_final = strtoupper($t_nom);
              $t_prenom_final = strtoupper($t_prenom[0]);
              $t_prenom_final.= substr(strtolower($t_prenom), 1, strlen($t_prenom) - 1);
        
              $t_description = $t_nom_final . " " . $t_prenom_final;

              if(!isset($s_password) || $s_password == "") {
                $s_password = user_generate_password();
              }

              if(!isset($s_login) || $s_login == "" 
              || user_is_login_free($s_login) == false) {
                $s_login = user_generate_login();
              }

              $sql = "INSERT INTO users ";
              $sql.= "(username, password, description, email, level) ";
              $sql.= "values('".$s_login."', '".md5($s_password)."', ";
              $sql.= "'".$s_description."', '".$s_email."', 1);";

              $db->query($sql);
              if($db->affected_rows() == 0) {
                $error_tab[$err_idx] = $bline;
                $err_idx ++;
              } else {
                $ok_idx ++;
                if($envoit_mail == 1 && $s_email != "") {

                  $to      = $t_description . "<".$s_email.">";
                  $s = ereg_replace("&lt;", "<", user_fromhead());
                  $s = ereg_replace("&gt;", ">", $s); 
                  $from    = "From: " . $s; 

                  $subject = "[TER]: Nouveau compte sur le site TER";
                  $message = "Bonjour,\n\n";
                  $message.= "Un compte sur le site TER vient de vous tre attribu:\n";
                  $message.= "Voici donc vos identifiants:\n\n";
                  $message.= "Login: ".$s_login."\n";
                  $message.= "Mot de passe: ".$s_password."\n";
                  $message.= "Site TER: $ter_location";
                  $message.= "\n\n"; 
                  $message.= "A bientot sur le site web TER !\nLe responsable.\n";
                  my_mail($to, $subject, $message, $from);
                }
              }

            } else {
              if($bline != "") {
                $error_tab[$err_idx] = $bline;
                $err_idx ++;
              }
            }
          }
          fclose($uf);

          if($err_idx != 0) {
            $error_message = "Les lignes suivantes n'ont pu tre ";
            $error_message.= "traites normalement: ($err_idx)<br />";
            for($i = 0; $i < $err_idx; $i ++) {
              $error_message.= $error_tab[$i]."<br />";
            }
          }
          if($ok_idx != 0) {
            $info_message = "$ok_idx tudiants ont t inscrits.";
          }
        }
      } else {
        $error_message = "Le fichier n'a pas pu tre trait: upload incorrect.";
      }
    }
  }

  if($_SERVER["REQUEST_METHOD"] == "GET") {
    /* On se prparer  effacer: demande de la confirmation */
    if(isset($_GET["effacerid"])) {
      $sid = fp2txtsql($_GET["effacerid"]);
      $sql = "select * from users where id = '$sid';";
      $db->query($sql);
      $tab = $db->fetch_array();
?>
<b>Confirmation</b>
<br /><br />
Effacer rellement l'tudiant&nbsp;
<?
      echo "<b>".$tab["description"]."</b>";
      echo " &lt;".$tab["email"]."&gt;  ";

      echo "? ";
      echo '<a href="?page=etudiants&amp;effaceridreel='.$sid.'">oui</a>';
      echo ' / ';
      echo '<a href="javascript:history.go(-1)">non</a>';
      return;
    }

    /* On efface, on crit un petit message. */
    if(isset($_GET["effaceridreel"])) {
      $sid = fp2txtsql($_GET["effaceridreel"]);
      $sql = "select * from users where id = '$sid';";
      $db->query($sql);

      if($db->affected_rows() == 1) {
        $tab_user = $db->fetch_array();

        /* On veut retirer la personne de son groupe. Hors, si c'est le 
           createur d'un groupe, il faut penser a y mettre une autre personne. */

        $sql = "select * from groupes_users where user_id = '$sid';";
        $db->query($sql);
        if($db->affected_rows() == 1) {
          $tab_gu = $db->affected_rows();
          $us_gid = $tab_gu["group_id"];

          $sql = "delete from groupes_users where user_id = '$sid';";
          $db->query($sql);

          $sql = "select * from groupes where owner_id = '$sid'";
          $sql.= " and group_id = '$us_gid';";
          $db->query($sql);

          if($db->affected_rows() == 1) {
            $sql = "select * from groupes_users where group_id = '";
            $sql.= $us_gid . "' order by user_id asc;";
            $db->query($sql);

            if($db->affected_rows() != 0) {
              $tab_users = $db->fetch_array();
              $sql = "update groupes set owner_id = '".$tab_users["user_id"];
              $sql.= "' where group_id = '" . $us_gid . "';";
              $db->query($sql);
            } else {
              /* On detruit le groupe. */
              $sql = "delete from groupes where group_id = '$us_gid';";
              $db->query($sql);

              /* Si le groupe avait un projet valide. */
              $sql = "update from projets set validgrp = 0 where validgrp = '".$us_gid."'";
              $db->query($sql);

              /* Soutenance */
              $sql = "delete from soutenances where group_id = '".$us_gid."'";
              $db->query($sql);
            } 
          }
        }

        $sql = "delete from users where id = '$sid';";
        $db->query($sql);

        $info_message = "L'effacement de l'tudiant ".$tab_user["description"];
        $info_message.= " a bien t effectu.<br />";
      } else {
        $error_messqge = "Cet etudiqnt n'existe pas.<br />";
      }
    }
  }

  /* 2nde etape: Affichage de la page */

?>
<b>Liste des tudiants</b>
<? interface_add_anchor("Liste des tudiants"); ?>
<br />
<br /><br />
<table border="1" cellspacing="1" cellpadding="4">
<tr>
  <td>id
  (<a href="?page=etudiants&amp;tri=id&amp;sens=asc">A</a>
   <a href="?page=etudiants&amp;tri=id&amp;sens=desc">V</a>)
  </td>
  <td>login
  (<a href="?page=etudiants&amp;tri=username&amp;sens=asc">A</a>
   <a href="?page=etudiants&amp;tri)username&amp;sens=desc">V</a>)
  </td>
  <td>identit
  (<a href="?page=etudiants&amp;tri=description&amp;sens=asc">A</a>
   <a href="?page=etudiants&amp;tri=description&amp;sens=desc">V</a>)
  </td>
  <td>email
  (<a href="?page=etudiants&amp;tri=email&amp;sens=asc">A</a>
   <a href="?page=etudiants&amp;tri=email&amp;sens=desc">V</a>)
  </td>
  <td>&nbsp;</td>
  <td>&nbsp;</td>
</tr>
<?
  if(isset($_GET["tri"]))
    $s_tri = mysql_escape_string($_GET["tri"]);
  else
    $s_tri = "id";

  if(isset($_GET["sens"]))
    $s_sens = mysql_escape_string($_GET["sens"]);
  else
    $s_sens = "asc";

  if($s_tri == "" 
  ||($s_tri != "id" 
    && $s_tri != "username" 
    && $s_tri != "description"
    && $s_tri != "email"))
    $s_tri = "id";

  if($s_sens == ""
  ||($s_sens != "asc"
    && $s_sens != "desc"))
    $s_sens = "asc";

  $sql = "select * from users where level = 1 order by $s_tri $s_sens";
  $db->query($sql);
  $num_row = $db->affected_rows();
  for($i = 0; $i < $num_row; $i ++) {
    $tab = $db->fetch_array();

    /* Retire les " indsirables ici,  cause du javascript ... */
    $tmp_str = ereg_replace("\"", "", $tab["description"]);

    $ret = preg_match("/([A-Z][^a-z]*) ([A-Z][^A-Z]*)/", 
                      $tmp_str, $identite);

    if($ret != 1) {
      $identite[1] = $tmp_str;
      $identite[2] = '';
    }

    echo "<tr>";
    echo "<td>" . $tab["id"] . "</td>";
    echo "<td>" . $tab["username"] . "</td>";
    echo "<td>" . $tab["description"] . "</td>";
    echo "<td><a href='mailto:" . $tab["email"] . "'>";
    echo $tab["email"];
    echo "</a></td>";
    echo "<td>";
    echo '<a href="#ajout" onclick="ajout_form.email.value=\'';
    echo sql2stxt($tab["email"]).'\';ajout_form.nom.value=\'';
    echo sql2stxt($identite[1]).'\';ajout_form.prenom.value=\'';
    echo sql2stxt($identite[2]).'\';ajout_form.modifier_login.value=\'';
    echo sql2stxt($tab["username"]).'\';ajout_form.login.value=\'';
    echo sql2stxt($tab["username"])." (non modif)".'\';';
    echo "ajout_form.ajout_button.value='modifier';";
    echo '">modifier</a>';
    echo "</td>";
    echo '<td><a href="?page=etudiants&amp;effacerid=';
    echo $tab["id"].'">effacer</a></td>';
    echo "</tr>\n";
  }
?>
</table>
<br /><br />
<? interface_add_anchor("Ajout/Modification d'tudiants"); ?>
<b>Ajout/Modification d'tudiants</b>
<br /><br />
<form action="?page=etudiants" method="post" name="ajout_form">
<input type="hidden" name="formulaire" value="ajout_form" />
<input type="hidden" name="modifier_login" value="" />
<table border="0">
  <tr>
    <td>Nom:</td>
    <td colspan="2"><input type="text" name="nom" value="" /></td>
  </tr>
  <tr>
    <td>Prnom:</td>
    <td colspan="2"><input type="text" name="prenom" value="" /></td>
  </tr>
  <tr>
    <td>Email:</td>
    <td colspan="2"><input type="text" name="email" value="" /></td>
  </tr>
  <tr>
    <td>Mot de passe:</td>
    <td><input type="password" name="password" value="" /></td>
    <td>Ce champ est facultatif. Si il est laiss vide, un mot de passe sera automatiquement gnr alatoirement. <b><font color='red'>Un email sera envoy uniquement si ce champs est modifi.</font></b></td>
  </tr>
  <tr>
    <td>Login:</td>
    <td><input type="text" name="login" value="" /></td>
    <td>Normalement, le login est cr  partir de la premire partie de
l'adresse email entre.<br />On utilisera ce champ uniquement pour ne pas 
gnrer le login  partir de cette adresse.</td>
  </tr>
</table>
<br />
<input type="button" name="effacer_button" value="tout effacer" 
       onclick="modifier_login.value='';email.value='';nom.value='';prenom.value='';login.value='';password.value='';ajout_button.value='ajout'" />
<input type="submit" name="ajout_button" value="ajout / modification" />
</form>
<br /><br /><br />
<? interface_add_anchor("Import fichier CSV d'tudiants"); ?>
<b>Import fichier CSV d'tudiants</b><br />
<br />
<form method="POST" action="?page=etudiants" name="import_csv"
      enctype="multipart/form-data">
<input type="hidden" name="formulaire" value="import_csv" />
<table border="0">
  <tr>
    <td>Fichier CSV:</td>
    <td><input type="file" name="myfile" size="50" /></td>
  </tr>
  <tr>
    <td colspan="2">
    <input type="checkbox" name="send_mail" checked />
      Envoyer un mail avec mot de passe pour l'import.
    </td>
  </tr>
  <tr>
    <td colspan="2">
      <input type="submit" name="up" value="Soumettre" />
    </td>
  </tr>
</table>
</form>
Attention: Selon le nombre d'tudiant  importer, cette procdure peut durer quelques dizaines de secondes pendant l'envoie des mails. Il est recommand de dcouper le fichier CSV en plusieurs parties si l'import choue.<br />
(Information: Le fichier CSV est de la forme:<br />
NOM;Prnom;email;login;pass</br>
Les champs login et pass sont facultatifs.
Si le champs email ne contient pas de '@', alors il sera considr qu'il s'agit
du login sur les systmes du CICT - ex: minfg42 - et il servira comme email (minfg42@cict.fr) et login 'minfg42')
<br />
<br />
