<?
  function export_table_users($file)
  {
    global $db;

    $sql = "select * from users;";
    $db->query($sql);

    $file_wr = fopen($file, "a+"); 
    if($file_wr == NULL)
      return(false);
    fwrite($file_wr, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
    fwrite($file_wr, "<users>\n");

    for($i = 0; $i < $db->affected_rows(); $i ++) {
      $tab = $db->fetch_array();
      fwrite($file_wr, "  <username>".$tab["username"]."</username>\n");
      fwrite($file_wr, "  <password>".$tab["password"]."</password>\n");
      fwrite($file_wr, "  <description>".$tab["description"]."</description>\n");
      fwrite($file_wr, "  <email>".$tab["email"]."</email>\n");
      fwrite($file_wr, "  <level>".$tab["level"]."</level>\n");
      fwrite($file_wr, "\n");
    }

    fwrite($file_wr, "</users>\n");
    fclose($file_wr);

    return(true);
  }

  function export_table_modules($file)
  {
    global $db;

    $sql = "select * from modules;";
    $db->query($sql);

    $file_wr = fopen($file, "a+");
    if($file_wr == NULL)
      return(false);
    fwrite($file_wr, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
    fwrite($file_wr, "<modules>\n");

    for($i = 0; $i < $db->affected_rows(); $i ++) {
      $tab = $db->fetch_array();
      fwrite($file_wr, "  <symb>".$tab["symb"]."</symb>\n"); 
      fwrite($file_wr, "  <nom>".$tab["nom"]."</nom>\n");
      fwrite($file_wr, "\n");
    }
    fwrite($file_wr, "</modules>\n");
    fclose($file_wr);

    return(true);
  }

  function export_table_edito($file)
  {
    global $db;
    $sql = "select * from edito;";
    $db->query($sql);

    $file_wr = fopen($file, "a+");
    if($file_wr == NULL)
      return(false);
    fwrite($file_wr, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
    fwrite($file_wr, "<edito>\n");
    $tab = $db->fetch_array();
    fwrite($file_wr, "<texte>".$tab["texte"]."</texte>\n");
    fwrite($file_wr, "</edito>\n");
    fclose($file_wr);

    return(true);
  }

  function export_table_groupes($file)
  {
    global $db;
    $sql = "select titre, username, optetat from groupes, users where owner_id = users.id;";
    $db->query($sql);

    $file_wr = fopen($file, "a+");
    if($file_wr == NULL)
      return(false);
    fwrite($file_wr, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
    fwrite($file_wr, "<groupes>\n");
    for($i = 0; $i < $db->affected_rows(); $i ++) {
      $tab = $db->fetch_array();
      fwrite($file_wr, "  <titre>".$tab["titre"]."</titre>\n");
      fwrite($file_wr, "  <username>".$tab["username"]."</username>\n");
      fwrite($file_wr, "  <optetat>".$tab["optetat"]."</opetat>\n");
      fwrite($file_wr, "\n");
    }
    fwrite($file_wr, "</groupes>\n");
    fclose($file_wr);

    return(true);
  }

  function export_table_groupes_users($file)
  {
    global $db;
    $sql = "select username, titre, etat from groupes_users, groupes, users where groupes_users.group_id = groupes.group_id and user_id = users.id;";
    $db->query($sql);

    $file_wr = fopen($file, "a+");
    if($file_wr == NULL)
      return(false);
    fwrite($file_wr, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
    fwrite($file_wr, "<groupes_users>\n");
    for($i = 0; $i < $db->affected_rows(); $i ++) {
      $tab = $db->fetch_array();
      fwrite($file_wr, "  <titre>".$tab["titre"]."</titre>\n");
      fwrite($file_wr, "  <username>".$tab["username"]."</username>\n");
      fwrite($file_wr, "  <etat>".$tab["etat"]."</etat>\n");
      fwrite($file_wr, "\n");
    }
    fwrite($file_wr, "</groupes_users>\n");
    fclose($file_wr);

    return(true);
  }

  function export_table_projets($file)
  {
    global $db;

    $file_wr = fopen($file, "a+");
    if($file_wr == NULL)
      return(false);
    fwrite($file_wr, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
    fwrite($file_wr, "<projets>\n");

    /* 1ere partie, projets non valids - validgrp == 0 */
    $sql = "select titre, info, typeproj, module, tailleq, validgrp, username from projets, users where users.id = id_auteur and validgrp = 0;"; 
    $db->query($sql);
    for($i = 0; $i < $db->affected_rows(); $i ++) {
      $tab = $db->fetch_array();
      fwrite($file_wr, "  <titre>".$tab["titre"]."</titre>\n");
      fwrite($file_wr, "  <info>".$tab["info"]."</info>\n");
      fwrite($file_wr, "  <typeproj>".$tab["typeproj"]."</typeproj>\n");
      fwrite($file_wr, "  <module>".$tab["module"]."</module>\n");
      fwrite($file_wr, "  <tailleq>".$tab["tailleq"]."</tailleq>\n");
      fwrite($file_wr, "  <validgrp>".$tab["validgrp"]."</validgrp>\n");
      fwrite($file_wr, "  <username>".$tab["username"]."</username>\n");
      fwrite($file_wr, "\n");
    }

    /* 2nde partie, projets valids - validgrp != 0 */
    $sql = "select groupes.titre as groupe, projets.titre, info, typeproj, module, tailleq,  username from projets, users, groupes where users.id = id_auteur and validgrp <> 0 and validgrp = groupes.group_id;";
    $db->query($sql);
    for($i = 0; $i < $db->affected_rows(); $i ++) {
      $tab = $db->fetch_array();
      fwrite($file_wr, "  <titre>".$tab["titre"]."</titre>\n");
      fwrite($file_wr, "  <info>".$tab["info"]."</info>\n");
      fwrite($file_wr, "  <typeproj>".$tab["typeproj"]."</typeproj>\n");
      fwrite($file_wr, "  <module>".$tab["module"]."</module>\n");
      fwrite($file_wr, "  <tailleq>".$tab["tailleq"]."</tailleq>\n");
      fwrite($file_wr, "  <validgrp>".$tab["groupe"]."</validgrp>\n");
      fwrite($file_wr, "  <username>".$tab["username"]."</username>\n");
      fwrite($file_wr, "\n");
    }

    fwrite($file_wr, "</groupes_users>\n");
    fclose($file_wr);

    return(true);
  }

  function export_table_choix($file)
  {
    global $db;

    $file_wr = fopen($file, "a+");
    if($file_wr == NULL)
      return(false);
    fwrite($file_wr, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
    fwrite($file_wr, "<choix>\n");

    $sql = "select titre, username from choix,projets,users where choix.projet_id = projets.id and user_id = users.id;";
    $db->query($sql);
    for($i = 0; $i < $db->affected_rows(); $i ++) {
      $tab = $db->fetch_array();
      fwrite($file_wr, "  <titre>".$tab["titre"]."</titre>\n");
      fwrite($file_wr, "  <username>".$tab["username"]."</username>\n");
      fwrite($file_wr, "\n");
    }
    fwrite($file_wr, "</choix>\n");
    fclose($file_wr);

    return(true);
  }

  function export_table_sout_creneaux($file)
  {
    global $db;

    $file_wr = fopen($file, "a+");
    if($file_wr == NULL)
      return(false);
    fwrite($file_wr, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
    fwrite($file_wr, "<sout_creneaux>\n");

    $sql = "select * from sout_creneaux;";
    $db->query($sql);
    for($i = 0; $i < $db->affected_rows(); $i ++) {
      $tab = $db->fetch_array();
      fwrite($file_wr, "  <debut>".$tab["debut"]."</debut>\n");
      fwrite($file_wr, "  <fin>".$tab["fin"]."</fin>\n");
      fwrite($file_wr, "\n");
    }
    fwrite($file_wr, "</sout_creneaux>\n");
    fclose($file_wr);
  
    return(true);
  }

  function export_table_espace($file)
  {
    global $db;

    $file_wr = fopen($file, "a+");
    if($file_wr == NULL)
      return(false);
    fwrite($file_wr, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
    fwrite($file_wr, "<espace>\n");

    $sql = "select titre, file_name from espace, projets where projets.id = espace.projet_id;";
    $db->query($sql);
    for($i = 0; $i < $db->affected_rows(); $i ++) {
      $tab = $db->fetch_array();
      fwrite($file_wr, "  <titre>".$tab["titre"]."</titre>\n");
      fwrite($file_wr, "  <file_name>".$tab["file_name"]."</file_name>\n");
      fwrite($file_wr, "\n");
    }

    fwrite($file_wr, "</espace>\n");
    fclose($file_wr);

    return(true);
  }

  function export_table_espace_comments($file)
  {
    global $db;

    $file_wr = fopen($file, "a+");
    if($file_wr == NULL)
      return(false);
    fwrite($file_wr, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
    fwrite($file_wr, "<espace_comments>\n");
    $sql = "select titre, comment_auteur, comment_contenu, comment_date from espace_comments, projets where projets.id = espace_comments.projet_id;";
    $db->query($sql);
    for($i = 0; $i < $db->affected_rows(); $i ++) {
      $tab = $db->fetch_array();
      fwrite($file_wr, "  <titre>".$tab["titre"]."</titre>\n");
      fwrite($file_wr, "  <comment_auteur>".$tab["comment_auteur"]."</comment_auteur>\n");
      fwrite($file_wr, "  <comment_contenu>".$tab["comment_contenu"]."</comment_contenu>\n");
      fwrite($file_wr, "  <comment_date>".$tab["comment_date"]."</comment_date>\n");
      fwrite($file_wr, "\n");
    }
    fwrite($file_wr, "</espace_comments>\n");

    return(true);
  }

  function export_table_soutenances($file)
  {
    global $db;

    $file_wr = fopen($file, "a+");
    if($file_wr == NULL)
      return(false);
    fwrite($file_wr, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
    fwrite($file_wr, "<soutenances>\n");
    $sql = "select * from soutenances, groupes where soutenances.group_id <> 0 and groupes.group_id = soutenances.group_id;";

    $db->query($sql);
    for($i = 0; $i < $db->affected_rows(); $i ++) {
      $tab = $db->fetch_array();
      fwrite($file_wr, "  <debut>".$tab["debut"]."</debut>\n"); 
      fwrite($file_wr, "  <titre>".$tab["titre"]."</titre>\n");
      fwrite($file_wr, "  <contenu>".$tab["contenu"]."</contenu>\n");
      fwrite($file_wr, "\n");
    }

    $sql = "select * from soutenances where soutenances.group_id = 0;";
    $db->query($sql);
    for($i = 0; $i < $db->affected_rows(); $i ++) {
      $tab = $db->fetch_array();
      fwrite($file_wr, "  <debut>".$tab["debut"]."</debut>\n");
      fwrite($file_wr, "  <titre>".$tab["titre"]."</titre>\n");
      fwrite($file_wr, "  <contenu>".$tab["contenu"]."</contenu>\n");
      fwrite($file_wr, "\n");
    }

    fwrite($file_wr, "</soutenances>\n");
    return(true);
  }
?>
