<?
  /*
   * mesg_not_auth_message_edit
   *
   * Envoit d'un message web non authentifi.
   */
  function mesg_not_auth_message_edit() {
    global $db, $error_message, $info_message;

    $s_nom = fp2txtsql($_POST["nom"]);
    $s_prenom = fp2txtsql($_POST["prenom"]);
    $s_email = fp2txtsql($_POST["email"]);
    $s_type = fp2txtsql($_POST["typemesg"]);
    $s_message = fp2htmlsql($_POST["message"]);

    if(is_numeric($s_type) == false || $s_type <= 0 || $s_type > 5) {
      $error_message = "Merci de choisir un type de message valide !<br />";
      return(-1);
    }

    if(is_email($s_email) == false) {
      $error_message = "Merci de spcifier une adresse email valide !<br />";
      return(-1);
    }

    $sql = "select id from users where level = 10;";
    $db->query($sql);
    $tab_responsable = $db->fetch_array();

    $s_fromid = -1;
    $s_toid = $tab_responsable["id"];

    switch($s_type) {
      default: $s_objet = "Autres"; break;
      case 1:  $s_objet = "Demande login encadrant"; break;
      case 2:  $s_objet = "Envoit suggestion de projet"; break;
      case 3:  $s_objet = "Besoin d'assistance"; break;
      case 4:  $s_objet = "Demande login tudiant"; break;
    }

    $s_texte = $s_message;
    $s_dateenvoit = time();
    $s_miscinfo = "";
    $s_typemesg = $s_type;

    $s_etat = 0;

    $s_nom_final = strtoupper($s_nom);
    $s_prenom_final = strtoupper($s_prenom[0]);
    $s_prenom_final.= substr(strtolower($s_prenom), 1, strlen($s_prenom) - 1);
    $s_description = $s_nom_final . " " . $s_prenom_final;
    $s_fromhead = "$s_description &lt;$s_email&gt;";

    $sql = "insert into messages(fromid, toid, fromhead, etat, objet, ";
    $sql.= "texte, typemesg, dateenvoit, miscinfo) values(";
    $sql.= "'".$s_fromid."', ";
    $sql.= "'".$s_toid."', ";
    $sql.= "'".$s_fromhead."', ";
    $sql.= "'".$s_etat."', ";
    $sql.= "'".$s_objet."', ";
    $sql.= "'".$s_texte."', ";
    $sql.= "'".$s_typemesg."', ";
    $sql.= "'".$s_dateenvoit."', ";
    $sql.= "'".$s_miscinfo."');"; 

    $db->query($sql);

    $info_message = "Votre message a bien t envoy.<br />";

    return(0);
  }

  /*
   * mesg_not_auth_message_form
   * 
   * Formulaire pour l'envoit d'un message quand on n'est pas authentifi
   */
  function mesg_not_auth_message_form() {

    if($_SERVER["REQUEST_METHOD"] == "POST") {
      $s_nom = fp2txt($_POST["nom"]);
      $s_prenom = fp2txt($_POST["prenom"]);
      $s_email = fp2txt($_POST["email"]);
      $s_type = fp2txt($_POST["typemesg"]);
      $s_message = fp2html($_POST["message"]);
    } else {
      $s_nom = "";
      $s_prenom = "";
      $s_email = "";
      $s_type = 0;
      $s_message = "";
    }
?>
<b>Envoit d'un message au responsable</b>
<br /><br />
<form action="?page=mesg" method="post" name="insc_encadrant_form">
<input type="hidden" name="formulaire" value="insc_encadrant_form" />
<table border="0">
<tr>
  <td>Nom:</td>
  <td><input type="text" name="nom" value="<? echo $s_nom; ?>" /></td>
</tr>
<tr>
  <td>Prenom:</td>
  <td><input type="text" name="prenom" value="<? echo $s_prenom; ?>" /></td>
</tr>
<tr>
  <td>Adresse email:</td>
  <td><input type="text" name="email" value="<? echo $s_email; ?>" /></td>
</tr>
<tr>
  <td>Type:</td>
  <td>
    <select name="typemesg">
      <option value="0">Choisissez le type du message</option>
      <option value="1">Demande login encadrant</option>
      <option value="2">Envoit suggestion de projet</option>
      <option value="3">Besoin d'assistance</option>
      <option value="4">Demande login tudiant</option>
      <option value="5">Autres</option>
    </select>
  </td>
</tr>
<tr>
  <td colspan="2">Message / Notes:</td>
</tr>
<tr>
  <td colspan="2"> 
     <textarea name="message" cols="50" rows="4"><? echo $s_message; ?></textarea>
  </td>
</tr>
</table>
<input type="submit" value="envoyer" />
</form>
<?
  }

  /*
   * mesg_listing 
   *
   * Liste les emails recus.
   */
  function mesg_listing() {
    global $db;
?>
<b>Votre messagerie</b>
<br /><br />
<a href="?page=mesg&amp;subsect=mail">Ecrire un message</a>
<br /><br />
<?
    if(isset($_GET["tri"]))
      $s_tri = mysql_escape_string($_GET["tri"]);
    else
      $s_tri = "id";

    if(isset($_GET["sens"]))
      $s_sens = mysql_escape_string($_GET["sens"]);
    else
      $s_sens = "asc";

    if($s_tri == "" 
    ||($s_tri != "id" 
      && $s_tri != "username" 
      && $s_tri != "description"
      && $s_tri != "email"))
      $s_tri = "id";

    if($s_sens == ""
    ||($s_sens != "asc"
      && $s_sens != "desc"))
      $s_sens = "asc";

    $sql = "select * from messages where toid = ".user_id();
    $sql.= " order by $s_tri $s_sens;";
    $db->query($sql);

    $num_row = $db->affected_rows();

    if($num_row <= 0) {
      echo "Vous n'avez <b>pas</b> de message.<br />";
      return;
    }
?>
<table border="1">
<tr>
  <td>id
  (<a href="?page=mesg&amp;tri=id&amp;sens=asc">A</a>
   <a href="?page=mesg&amp;tri=id&amp;sens=desc">V</a>)
  </td>
  <td>from
  (<a href="?page=mesg&amp;tri=fromhead&amp;sens=asc">A</a>
   <a href="?page=mesg&amp;tri=fromhead&amp;sens=desc">V</a>)
  </td>
  <td>objet
  (<a href="?page=mesg&amp;tri=objet&amp;sens=asc">A</a>
   <a href="?page=mesg&amp;tri=objet&amp;sens=desc">V</a>)
  </td>
  <td>date
  (<a href="?page=mesg&amp;tri=dateenvoit&amp;sens=asc">A</a>
   <a href="?page=mesg&amp;tri=dateenvoit&amp;sens=desc">V</a>)
  </td>
  <td colspan="3">&nbsp;</td>
</tr>
<?
    for($i = 0; $i < $num_row; $i ++) {
      $tab = $db->fetch_array();
      if($tab["etat"])
        echo "<tr bgcolor='lightred'>";
      else
        echo "<tr bgcolor='lightgreen'>";
      echo "<td>".$tab["id"]."</td>";
      echo "<td>";
      eregi("(.*)&lt(.*)", $tab["fromhead"], $tmpres);
      echo "<a href=\"mailto:".$tab["fromhead"]."\">".$tmpres[1]."</a>";
      echo "</td>";
      echo "<td>".$tab["objet"]."</td>";
      echo "<td>".user_showdateshort($tab["dateenvoit"])."</td>";

      echo "<td>";
      echo "<a href=\"?page=mesg&amp;subsect=read&amp;id=".$tab["id"]."\">";
      echo "Lire</a>";
      echo "</td>";

      echo "<td>";
      if($tab["fromid"] == -1) {
        echo "<a href=\"mailto:".$tab["fromhead"]."\">Rpondre</a>";
      } else {
        echo "<a href=\"?page=mesg&amp;subsect=mail&amp;id=";
        echo $tab["id"]."\">Rpondre</a>";
      }
      echo "</td>";
     
      echo "<td>";
      echo "<a href=\"?page=mesg&amp;subsect=clean&amp;id=".$tab["id"]."\">";
      echo "Effacer</a>";
      echo "</td>";
      echo "</tr>\n";
    }
?>
</table>
<br />
<?
  }

  /*
   * mesg_read 
   *
   * Lis un email en particulier
   */
  function mesg_read() {
    global $db, $info_message, $error_message;

    $s_id = mysql_escape_string($_GET["id"]);

    $sql = "select * from messages where id = $s_id and toid = ".user_id().";";

    $db->query($sql);
    if($db->affected_rows() != 1) {
      $error_message = "Ce message ne peut tre retrouv.";
      return;
    }
    $tab = $db->fetch_array();

?>
<b>Message:</b><br /><br />
<b>De:</b> <a href='mailto:<? echo $tab["fromhead"]; ?>?subject=<? echo "Re: " . $tab["objet"]; ?>'>
<? echo $tab["fromhead"]; ?></a>
<br />
<b>Objet:</b> <? echo $tab["objet"]; ?><br />
<b>Date:</b> <? echo user_showdate($tab["dateenvoit"]); ?><br />
<b>Contenu:</b><br /><br />
<? echo $tab["texte"]; ?>
<br /><br />
<?
    /* Marquer le mail comme lu */
    $etat = 1;
    $sql = "update messages set etat = ";
    if($tab["etat"] != 1 && $tab["etat"] != 3) 
      $etat += $tab["etat"];
    $sql.= $etat . " where id = '".$tab["id"]."';";
    $db->query($sql);
    /* Grer les diffrents types de messages si besoin */
    if($tab["etat"] == 3) {
      echo "Action valide.";
    } else { 
    switch($tab["typemesg"]) {
      case 5: /* Rserv pour messages sans type prcis. */
      default: break;
      case 1: /* Demande login encadrant */
      break;
      case 6: /* Demande pour joindre un groupe */
?>
<b>Accepter</b> cette demande de "<? echo $tab["fromhead"]; ?>" ?&nbsp;
<a href="?page=mesg&amp;subsect=approve&amp;id=<?echo $s_id;?>">oui</a>
&nbsp;-&nbsp; 
<a href="?page=mesg&amp;subsect=unapprove&amp;id=<?echo $s_id;?>">non</a>
<br /><br />
<?
      break;
    }
    if($tab["typemesg"] == 2) {

      $ret = preg_match("/([A-Z][^a-z]*) ([A-Z][^A-Z< ]*) &lt;(.*)&gt;/",
                        $tab["fromhead"], $identite);

      if($ret != 1) {
        $identite[1] = $tab["fromhead"];
        $identite[2] = '';
        $identite[3] = '';
      }
?>
  Validez cette demande en compltant ce formulaire:<br /><br />
<?
      form_ajout($identite, "etudiants");
      echo "<br /></br />";
    }
    if($tab["typemesg"] == 1) { 

      $ret = preg_match("/([A-Z][^a-z]*) ([A-Z][^A-Z< ]*) &lt;(.*)&gt;/",
                        $tab["fromhead"], $identite);

      if($ret != 1) {
        $identite[1] = $tab["fromhead"];
        $identite[2] = '';
        $identite[3] = '';
      }
?>
  Validez cette demande en compltant ce formulaire:<br /><br />
<?
      form_ajout($identite, "encadrants");
      echo "<br /></br />";
    }
    } /* if etat == 0 */
?>
<br />Retour <a href="?page=mesg&amp;subsect=list">listing</a>&nbsp;-&nbsp;
<a href="?page=mesg&subsect=clean&id=<? echo $s_id; ?>">effacer</a>
<?
  } /* fin fonction mesg_read */

  /*
   * mesg_clean
   *
   * Effacer un message
   */
  function mesg_clean() {
    global $db, $info_message, $error_message;

    $s_id = mysql_escape_string($_GET["id"]);

    $sql = "delete from messages where id = $s_id and toid = ".user_id().";";
    $db->query($sql);
    if($db->affected_rows() != 1) {
      $error_message = "Ce message ne peut tre effac. / Message inexistant.";
    } else {
      $info_message = "Message effac.";
    }
  }

  /*
   * mesg_new_edit
   * 
   * Envoit d'un email (aprs validation)
   */
  function mesg_new_edit() {
    global $db, $info_message, $error_message;

    if(isset($_POST["formulaire"]) == false
    || $_POST["formulaire"] != "mesg_new")
      return ;

    /* Bonne section, on envoit le message. */

    $s_message = fp2htmlsql($_POST["message"]);
    $s_objet = fp2txtsql($_POST["objet"]);
    $s_dest  = fp2txt($_POST["peuple"]);

    /*
     * Envoit  d'autres:
     *
  <option value="-1">Tout le monde</option>
  <option value="-2">Tout les tudiants</option>
  <option value="-3">Tout les tudiants sans projets valids</option>
  <option value="-4">Tout les tudiants sans groupes</option>
  <option value="-5">Tout les encadrants</option>
  <option value="-6">Tout les encadrants avec un projet non valid</option>
     */

    if($s_dest > 0) {
      mesg_quick($s_dest, $s_objet, $s_message);
    } else {
      switch($s_dest) {
        default:
          $error_message = "Le message n'a pas pu tre dlivr.";
          return;
        break;

        case -1:
          $sql = "select id from users;";
        break;

        case -2:
          $sql = "select id from users where level = 1 order by id asc;";
        break;

        case -3: /* XXX */
        break;

        case -4:
          $sql = "select * from users left outer join groupes_users on users.id = user_id where user_id is null and level = 1";
        break;

        case -5:
          $sql = "select * from users where level = 5;";
        break;

        case -6: /* XXX */
          $sql = "";
        break;
      }

      /* XXX: database class is smelling. */
      $n = $db->query($sql);
      $num_row = $db->affected_rows();
      for($i = 0; $i < $num_row; $i ++) {
        $tab = $db->fetch_array($n);
        mesg_quick($tab["id"], $s_objet, $s_message);
      }
    }

    $info_message = "Le message a bien ete envoye.";

    return ;
  }

  /*
   * mesg_new_form
   * 
   * Formulaire pour envoyer un nouvel email
   */
  function mesg_new_form() {
    global $db;

    if(isset($_GET["id"]) == true) {
      $s_id = fp2txtsql($_GET["id"]); 
      $sql = $db->query("select * from messages where id = $s_id and toid = ".user_id().";");
      $tab = $db->fetch_array();
      $s_objet = "Re: ".$tab["objet"];
      $s_toid = $tab["fromid"];
      $s_oldmesg = ereg_replace("^", "&gt; ", $tab["texte"]);
      $s_oldmesg = ereg_replace("\n","\n&gt; ", $s_oldmesg);
    }

?>
<b>Envoit d'un message</b>
<br /><br />
<form method="post" action="?page=mesg&amp;subsect=mailsend">
<input type="hidden" name="formulaire" value="mesg_new" />
<table border="0">
<tr>
  <td>Objet:</td>
  <td><input type="text" name="objet" value="<? if(isset($s_objet)) echo $s_objet; ?>" /></td>
</tr>
<tr>
  <td>Destinataire:</td>
  <td>
<select name="peuple">
<?
    if(isset($s_toid) == false) {
?>
  <option value="0" selected>-- Choisissez un destinataire --</option>
<?
    } else {
?>
  <option value="0">-- Choisissez un destinataire --</option>
<?
    }

    if($_SESSION["user_level"] >= 5) {
?>
  <option value="-1">Tout le monde</option>
  <option value="-2">Tout les tudiants</option>
  <option value="-4">Tout les tudiants sans groupes</option>
  <option value="-5">Tout les encadrants</option>
<?
    }

    $last_lvl = 42;
    $sql = "select * from users order by level desc, description asc;";
    $db->query($sql);
    $num_row = $db->affected_rows();
    for($i = 0; $i < $num_row; $i ++) {
      $tab = $db->fetch_array();
      if($tab["level"] != $last_lvl) {
        echo "<option value=\"0\">";
        switch($tab["level"]) {
          case 10: echo "-- Responsable --"; break;
          case 5: echo "-- Encadrants --"; break;
          case 1: echo "-- Etudiants --"; break;
        }
        echo "</option>";
        $last_lvl = $tab["level"];
      }
      echo "<option value=\"".$tab["id"]."\" ";
      if(isset($s_toid) == true && $s_toid == $tab["id"])
        echo "selected";
      echo ">".$tab["description"];
      echo "</option>\n";
    }
?>
</select>
  </td>
</tr>
<tr><td colspan="2">Contenu:</td></tr>
<tr>
  <td colspan="2">
    <textarea name="message" cols="50" rows="7"><?if(isset($s_oldmesg)) echo $s_oldmesg;?></textarea>
  </td>
</tr>
</table>
<input type="submit" name="" value="Envoyer" />
</form>
<br />Retour <a href="?page=mesg&amp;subsect=list">listing</a>
<?
  }

  /*
   * mesg_approve (fait aussi office de mesg_unapprove)
   *
   * Pour approver certains messages (validation groupe, nvl encadrant...)
   */
  function mesg_approve() { 
    global $db, $subsect;
    global $info_message, $error_message;

    $s_subsect = fp2txtsql($_GET["subsect"]);
    $s_id = mysql_escape_string($_GET["id"]);

    $sql = "select * from messages where id = $s_id and toid = ".user_id().";";

    $db->query($sql);
    if($db->affected_rows() != 1) {
      $error_message = "Ce message ne peut tre retrouv.";
      return;
    }
    $tab = $db->fetch_array();

    switch($tab["typemesg"]) {
      default: break;
      case 6:
        if($s_subsect == "approve") {
          $sql = "update groupes_users set etat = 1 ";
          $sql.= "where group_id = ".user_g_id()." ";
          $sql.= "and user_id = ".$tab["fromid"].";";
          $db->query($sql);

          $sql = "update messages set typemesg = 5 ";
          $sql.= "where id = $s_id;"; 
          $db->query($sql);

          $info_message = "Cette confirmation a t valide. Merci !";

          mesg_quick($tab["fromid"],
             "Acceptation dans le groupe ".user_g_titre(),
             "Vous avez t accept dans le groupe ".user_g_titre());
        } /* Fin subsect == approve */
        if($s_subsect == "unapprove") {
          $sql = "delete from groupes_users ";
          $sql.= "where group_id = ".user_g_id()." ";
          $sql.= "and user_id = ".$tab["fromid"].";";
          $db->query($sql);

          $sql = "update messages set typemesg = 5 ";
          $sql.= "where id = $s_id;"; 
          $db->query($sql);

          $info_message = "Ce rejet a t notifi. Merci !";

          mesg_quick($tab["fromid"],
             "Vous avez t refus d'entrer dans le groupe ".user_g_titre(),
             "Dsol, vous avez t refus d'entre dans el groupe ".
             user_g_titre());
        } /* Fin subsect == unapprove */
      break;
    }
  }

  /*
   * mesg_quick
   *
   * Envoit un message normal
   */
  function mesg_quick($toid, $objet, $texte) {
    global $db;

    $s_fromid = user_id();
    $s_toid = $toid;
    $s_fromhead = user_fromhead();
    $s_etat = 0;
    $s_objet = $objet;
    $s_texte = $texte;   
    $s_typemesg = 5;
    $s_dateenvoit = time();
    $s_miscinfo = "";

    $sql = "insert into messages(fromid, toid, fromhead, etat, objet, ";
    $sql.= "texte, typemesg, dateenvoit, miscinfo) values(";
    $sql.= "'".$s_fromid."', ";
    $sql.= "'".$s_toid."', ";
    $sql.= "'".$s_fromhead."', ";
    $sql.= "'".$s_etat."', ";
    $sql.= "'".$s_objet."', ";
    $sql.= "'".$s_texte."', ";
    $sql.= "'".$s_typemesg."', ";
    $sql.= "'".$s_dateenvoit."', ";
    $sql.= "'".$s_miscinfo."');";

    $db->query($sql);
  }
?>
