<?
  $menu_pages = array(
    "default" => array(
      "nom" => "Page TER",
      "nomfichier" => "default.php",
      "nomtag" => "default",
      "level" => 0),

    "perso" => array(
      "nom" => "Page perso",
      "nomfichier" => "perso.php",
      "nomtag" => "perso",
      "level" => 1),
      
    "etudiants" => array(
      "nom" => "Etudiants",
      "nomfichier" => "etudiants.php",
      "nomtag" => "etudiants",
      "level" => 10),

    "encradrants" => array(
      "nom" => "Encadrants",
      "nomfichier" => "encadrants.php",
      "nomtag" => "encadrants",
      "level" => 10),

    "espace" => array(
      "nom" => "Espace projet",
      "nomfichier" => "espace.php",
      "nomtag" => "espace",
      "level" => 1),

    "projets" => array(
      "nom" => "Projets",
      "nomfichier" => "projets.php",
      "nomtag" => "projets",
      "level" => 0),

    "mesg" => array(
      "nom" => "Messagerie",
      "nomfichier" => "mesg.php",
      "nomtag" => "mesg",
      "level" => 0),

    "encadrer" => array(
      "nom" => "Encadrement de projets",
      "nomfichier" => "encadrer.php",
      "nomtag" => "encadrer",
      "level" => 5),

    "voeux" => array(
      "nom" => "Voeux tudiants",
      "nomfichier" => "voeux.php",
      "nomtag" => "voeux",
      "level" => 0),

    "soutenance" => array(
       "nom" => "Soutenances",
       "nomfichier" => "soutenance.php",
       "nomtag" => "soutenance", 
       "level" => 0),

    "admin" => array(
       "nom" => "Administration",
       "nomfichier" => "admin.php",
       "nomtag" => "admin",
       "level" => 10),

    "logout" => array(
      "nom" => "Deconnexion",
      "nomfichier" => "default.php",
      "nomtag" => "partir",
      "level" => 1)
  );

  /*
   * menu_choose_page
   *
   * Cette fonction prend la page demand dans ?page= (variable $page), 
   * et cherche sa correspondance dans le tableau ci dessus.
   * Si un probleme de droits est repr, ou si la page n'existe pas, alors
   * on revoit l'utilisateur sur "default".
   */
  function menu_choose_page() {
    /* menu_page_tab contient le tabeau contenant les diffrentes compostantes
       du menu. */
    global $menu_page_tab, $page;
    global $menu_pages;

    if(isset($_REQUEST["page"])) {
      $page = $_REQUEST["page"];
    }

    /* Si la page n'a pas t dfinie, alors on va sur la page par dfaut. */
    if(!isset($page) || $page == "") {
      $page = "default";
    }    

    /* Pour chaque pages accessibles ... */
    foreach($menu_pages as $idx) {
      if($idx["nomtag"] == "default")
        $menu_page_tab = $idx;

      if($page == $idx["nomtag"]) {
        if($_SESSION["user_level"] >= $idx["level"]) {
        /* Si l'utilisateur demande une page  laquelle il n'a pas le droit,
           on le renvoit sur la page par dfaut. */
        $menu_page_tab = $idx;
        } else {
          /* Bonne page, pas le droit => page de garde */
          $page = "default";
        }
      }
    }
  }
?>
