<?
  /* Script protection */

  if(function_exists("user_script_valid") == FALSE) {
    die(""); 
  } else {
    user_script_valid();
  }

  /*
   * Module: Page personnelle.
   * Accessible par tous, cette page informe les usagers sur le systeme, et
   * leur permet de faire des changements gnraux au site (changement de mot
   * de passe ou d'email, changement d'edito pour le responsable, ...) 
   */
  global $db;

  /* 1ere etape: Si on a des formulaires  traiter */
  if($_SESSION["user_level"] > 0) {

    /* Si c'est un responsable */
    if($_SESSION["user_level"] >= 10) {
      perso_edito_edit();
      perso_password_edit();
    }

    /* Si c'est un encadrant ou un responsable */
    if($_SESSION["user_level"] >= 5) {
    }

    /* Si c'est un tudiant ou un encadrant ou un responsable */
    if($_SESSION["user_level"] >= 1) {
      perso_info_edit();
    }

    if($_SESSION["user_level"] == 1) {
      perso_group_valid();
      perso_group_assign();
      perso_group_remove();
      perso_group_open_close();
      perso_group_create_edit();
      perso_group_join();
      perso_group_leave_edit();
    } 
  }

  /* 2nde etape: Affichage de la page */
  if($_SESSION["user_level"] > 0) { /* On est loggu au systeme */
    interface_add_anchor("Page principale");
    echo "<b>Page principale</b> de";
    echo ": <b>".$_SESSION["user_description"]."</b>.<br />";
    $sql = "select * from messages where toid = ".user_id()." and etat = 0;";
    $db->query($sql);
    if($db->affected_rows()) {
      echo "Vous avez ". $db->affected_rows(). " messages en attente d'etre lus.<br />";
    }
  }

  if($_SESSION["user_level"] >= 10) {
    $sql = "select count(*) from users where level = 1;";
    $db->query($sql);
    $tab = $db->fetch_array();
    echo "<br />";
    echo "<b>" . $tab["count(*)"] . "</b> tudiants.<br />";
    $sql = "select count(*) from users where level = 5;";
    $db->query($sql);
    $tab = $db->fetch_array();
    echo "<b>" . $tab["count(*)"] . "</b> encadrants.<br />";
  }

  if($_SESSION["user_level"] == 10) {
    $sql = "select email from users where level = 1";
    $db->query($sql);
    $num = $db->affected_rows();
    $str = "";
    for($p = 0; $p < $num; $p ++) {
      $tab = $db->fetch_array();
      $str.= $tab["email"];
      if($p != $num - 1)
        $str .= ",";
    }
    echo "<br />";

    if(strlen($str) >= 2048) {
      echo "La liste des mails est trop grande pour effectuer un envoit collectif. ";
      echo "Merci d'utiliser <a href='mailto:minfg@cict.fr'>minfg@cict.fr</a><br />";
    } else {
      echo "<a href='mailto:$str'>Envoit email  tout les tudiants</a><br />";
    } 

    $sql = "select email from users where level = 5";
    $db->query($sql);
    $num = $db->affected_rows();
    $str = "";
    for($p = 0; $p < $num; $p ++) {
      $tab = $db->fetch_array();
      $str.= $tab["email"];
      if($p != $num - 1)
        $str .= ",";
    }

    if(strlen($str) < 2048) {
      echo "<a href='mailto:$str'>Envoit email  tous les encadrants</a><br />";
    }

    $sql = "select * from users where level = 1";
    $db->query($sql);
    $tab_all = $db->fetch_all_array();
    $num_all = $db->affected_rows();

    $sql = "select user_id from groupes_users;";
    $db->query($sql);
    $n = $db->affected_rows();
    $tab_rag = $db->fetch_all_array();
    $str = "";
    for($i = 0; $i < $num_all; $i ++) {
      $dedans = 0;
      for($j = 0; $j < $n; $j ++) {
        if($tab_all[$i]["id"] == $tab_rag[$j]["user_id"]) {
          $dedans = 1;
          break;
        }
      }

      if($dedans == 0) {
        if($str != "") $str .= ",";
        $str.= $tab_all[$i]["email"];
      }
    }

    if(strlen($str) >= 2048) {
      echo "La liste des adresses est trop grande pour effectuer un envoit  tout les tudiants sans groupes.<br />";
    } else {
      echo "<a href='mailto:$str'>Envoit email  tout les tudiants sans groupes</a><br />";
    }

    /* XXX */

    $sql = "select * from users,groupes,groupes_users,projets where users.id = groupes_users.user_id and groupes_users.group_id = groupes.group_id and projets.validgrp = groupes.group_id;";
    $db->query($sql);
    $num = $db->affected_rows();
    $taba = $db->fetch_all_array();
    $str = "";
    for($p = 0; $p < $num; $p ++) {
      $tab = $db->fetch_array();
      $str.= $taba[$p]["email"];
      if($p != $num - 1)
        $str .= ",";
    }

    if(strlen($str) < 2048) {
      echo "<a href='mailto:$str'>Envoit email  tout les tudiants ayant valid un projet.</a><br />";
    }

    $sql = "select * from users where level = 1;";
    $db->query($sql);
    $num_users = $db->affected_rows();
    $tab_users = $db->fetch_all_array();
    $str = "";
    for($i = 0; $i < $num_users; $i ++) {
      $dedans = 0;
      for($j = 0; $j < $num; $j ++) {
        if($tab_users[$i]["id"] == $taba[$j]["user_id"]) {
          $dedans = 1;
          break;
        }
      }

      if($dedans == 0) {
        if($str != "") $str .= ",";
        $str.= $tab_users[$i]["email"];
      }
    }

    if(strlen($str) < 2048) {
      echo "<a href='mailto:$str'>Envoit email  tout les tudiants n'ayant pas de projet.</a>";
    } else {
      echo "Trop d'tudiants n'ayant pas de projet pour l'envoit d'un mail.<br />";
    }
  }

  if($_SESSION["user_level"] == 1) {
    if(user_g_titre() != "") {
      if(user_g_etat() == 1) {
        echo "<br>";
        echo "Vous faites parti du groupe <b>".user_g_titre()."</b>.";
        $sql = "select * from groupes where group_id = '".user_g_id()."';"; 
        $db->query($sql);
        $tab_grp = $db->fetch_array();
        if($tab_grp["owner_id"] == user_id()) {
          echo " Vous en tes d'ailleurs le <b>responsable</b>.";
        }
        echo "<br />";
        if($tab_grp["optetat"] != 1) {
          echo "(<a href=\"?page=perso&amp;partirgroupe=".user_g_id()."\">";
          echo "Partir</a> de ce groupe.) <br />";
        } else {
          echo "Ce groupe est ferm aux inscriptions et dsincriptions.<br />";
        }
        echo "<br />"; 

        if(user_g_projet() != -1) {
          echo "Votre groupe a valid le ";
          echo "<a href='?page=projets&amp;subsect=voir&amp;id=".user_g_projet()."'>";
          echo "projet ".user_g_projet();
          echo "</a>";
          echo ":&nbsp;";
          $sql = "select * from projets where id = '".user_g_projet()."';";
          $db->query($sql);
          $tabproj = $db->fetch_array();
          echo "<b>".$tabproj["titre"]."</b>";
          echo "<br /><br />";
        }

        if($tab_grp["owner_id"] == user_id()) {
          /* Administration du groupe */
          interface_add_anchor("Administration du groupe");
          echo "<b>Administration de votre groupe</b><br /><br />";
          $sql = "select * from groupes, users, groupes_users where users.id = groupes_users.user_id and groupes.group_id = groupes_users.group_id and groupes_users.group_id = '".user_g_id()."' order by description asc;";
          $db->query($sql);
          $tab_user = $db->fetch_all_array();

          if($tab_user[0]["optetat"] == 1) { /* 1 == locked, 0 == unlocked*/
            echo "Le groupe est ferm aux inscriptions/dsinscriptions. ";
            echo "(<a href='?page=perso&amp;open=".user_g_id()."'>ouvrir</a>)";
          } else {
            echo "Le groupe est ouvert aux inscriptions/dsinscriptions. ";
            echo "(<a href='?page=perso&amp;close=".user_g_id()."'>fermer</a>)";
          }
          echo "<br />";
          echo "<br />";
          echo "<table border='1'>";
          for($i = 0; $i < $db->affected_rows(); $i ++) {
            echo "<tr>";
            echo "<td>";
            echo $tab_user[$i]["description"];
            echo "</td>";
            echo "<td>";
            echo "<a href='mailto:".$tab_user[$i]["email"]."'>";
            echo $tab_user[$i]["email"]."</a>";
            echo "</td>";
            echo "<td>";
            if($tab_user[$i]["id"] != user_id()) {
              echo "<a href='?page=perso&remove=".$tab_user[$i]["id"]."'>retirer</a> ";
              echo "du groupe</a>";
            } else {
              echo "<a href='?page=perso&amp;partirgroupe=".user_g_id()."'>";
              echo "partir</a> de ce groupe.";

            } 
            echo "</td>";
            echo "<td>";
            /* 1er cas: on est dans le cas ou on est dans le groupe */
            if($tab_user[$i]["etat"] ==  1) { 
              if($tab_user[$i]["id"] != user_id()) {
                echo "<a href='?page=perso&assign=".$tab_user[$i]["id"]."'>";
                echo "assigner</a> ";
                echo "comme nouveau responsable";
              } else {
                echo "Vous tes le responsable.";
              }
            } else {
              echo "<a href='?page=perso&validgrp=".$tab_user[$i]["id"]."'>";
              echo "Valider la demande de faire partis du groupe.</a>";
            }
            echo "</td>";
            echo "</tr>";
          }
          echo "</table>";
        }

      } else {
        echo "Vous avez demande a faire parti du groupe <b>";
        echo user_g_titre()."</b>.<br />";
        echo "(<a href=\"?page=perso&amp;partirgroupe=".user_g_id()."\">";
        echo "Rsigner</a> de ce groupe.) <br /><br />"; 
      }
    } else {
      echo "Vous ne faites <b>pas</b> parti d'un groupe.<br />";
      perso_group_create_form();
    }

    if($_SESSION["user_level"] == 1) {
      interface_add_anchor("Mes voeux");
      echo "<b>Mes voeux</b><br /><br />";
      $sql = "select * from projets,choix where user_id = '".user_id()."' and choix.projet_id = projets.id;";
      $db->query($sql);
      if($db->affected_rows() == 0) {
        echo "Pas de voeux pour le moment.";
      } else {
        $num_voeux = $db->affected_rows();
        for($i = 0; $i < $num_voeux; $i ++) {
          $tab_voeux = $db->fetch_array();
          echo "* ". $tab_voeux["projet_id"]." -  ";
          echo "<a href='?page=projets&amp;subsect=voir&amp;id=";
          echo $tab_voeux["projet_id"];
          echo "'>";
          echo $tab_voeux["titre"];
          echo "</a><br />";
        }
      }
    echo "<br /><br />";
    }
  }
  
  echo "<br /><br />";
  if($_SESSION["user_level"] >= 1) {
    perso_info_form();
  }

  if($_SESSION["user_level"] >= 10) {
    perso_edito_form();
    perso_password_form();
  }

  /*
   * perso_edito_form 
   *
   * Affiche le formulaire pour le changement d'edito (responsable seulement)
   */
  function perso_edito_form() {
    global $db;
    interface_add_anchor("Modification de l'dito");
?>
<b>Modification de l'dito:</b>
<br /><br />
<form action="?page=perso" method="post" name="edito_form">
<input type="hidden" name="formulaire" value="edito_form" />
<textarea name="edito_text" cols="50" rows="3"><?
  $sql = "select * from edito;";
  $db->query($sql);
  if($db->affected_rows()) {
    $tab = $db->fetch_array();
    echo $tab["texte"];
  }
?></textarea>
<br /><br />
<input type="submit" name="edito_button" value="modifier" />
<input type="submit" name="edito_button" value="effacer" />
</form>
<br /><br />
<?
  }

  /*
   * perso_info_form 
   *
   * Affichage du formulaire "changement mot de passe et / ou email".
   */
  function perso_info_form() {
    global $db;

    $db->query("select * from users where username = '".
               $_SESSION["user_username"]."';");
    $tab = $db->fetch_array();
    interface_add_anchor("Modification de vos paramtres");
?>
<b>Modification de vos paramtres personnels:</b>
<br /><br />
<form action="?page=perso" method="post" name="info_form">
<input type="hidden" name="formulaire" value="info_form" />
<table border="0">
  <tr>
    <td>Email:</td>
    <td><input type="text" name="email" value="<?echo $tab["email"];?>" /></td>
  </tr>
  <tr>
    <td>Mot de passe:</td>
    <td><input type="password" name="password" value="" /></td>
  </tr>
  <tr>
    <td>Mot de passe (confirmation):</td>
    <td><input type="password" name="password_conf" value="" /></td>
  </tr>
</table>
<br />
<input type="submit" name="edito_button" value="modifier" />
</form>
<br /><br />
<?
  }

  /*
   * perso_password_form
   *
   * Affiche le formulaire pour changer un mot de passe d'un utilisateur.
   * (responsable seulement)
   */
  function perso_password_form() {
    global $db;

    interface_add_anchor("Modification d'un mot de passe");
?>
<b>Modification (et envoie par email) d'un mot de passe:</b>
<br /><br />
<form action="?page=perso" method="post" name="password_form">
<input type="hidden" name="formulaire" value="password_form" />
<table border="0">
  <tr>
    <td>Personne:</td>
    <td colspan="2">
      <select name="password_sel">
<?
    $db->query("select * from users order by level desc, username asc;");
    $num_row = $db->affected_rows();
    for($i = 0; $i < $num_row; $i ++) {
      $tab = $db->fetch_array();
      echo '<option value="'.$tab["username"].'">';
      echo $tab["description"];
      echo '</option>'."\n";
    }
?>
      </select>
    </td>
  </tr>
  <tr>
    <td>Mot de passe:</td>
    <td><input type="password" name="password" value="" /></td>
    <td>Ce champ est facultatif. Si il est laiss vide, un mot de passe sera automatiquement gnr alatoirement.</td>
  </tr>
</table>
<br />
<input type="submit" name="password_button" value="modifier et envoyer" />
</form>
<br /><br />
<?
  }

  /*
   * perso_edito_edit 
   *
   * On a dit ou effac l'dito. Cette fonction modifie cela dans la base
   * de donnes.
   */
  function perso_edito_edit() {
    global $db, $info_message;

    if($_SERVER["REQUEST_METHOD"] == "POST"
    && isset($_POST["formulaire"]) 
    && $_POST["formulaire"] == "edito_form") {
      switch($_POST["edito_button"]) {
        /* Cas on efface l'edito */
        case "effacer":
          $sql = "update edito set texte = '';";
          $db->query($sql);
          $info_message = "L'dito a t effac.";
        break;
        /* Cas on modifie l'edito */
        case "modifier":
          $nouvel_edito = fp2htmlsql($_POST["edito_text"]);
          $sql = "update edito set texte = '".$nouvel_edito."';";
          $db->query($sql);
          $info_message = "L'dito a t modifi.";
        break;
        default:
      }
    } 
  }

  /*
   * perso_group_leave_edit
   *
   * Partir du dit groupe
   */
  function perso_group_leave_edit() {
    global $db, $info_message, $error_message;

    if(isset($_GET["partirgroupe"]) == true
    && $_GET["partirgroupe"] == user_g_id()) {
      /* On quitte le groupe */

      $sql = "select * from groupes where group_id = '".user_g_id()."';";
      $db->query($sql);
      $tab_grp = $db->fetch_array();

      /* Si l'on veut rsigner du groupe, on fait un delete si etat = 0 
       * C'est pas trs propre, mais c'est une solution rapide avant
       * de tester si l'on est rllement dans le groupe.
       */

      $sql = "delete from groupes_users where user_id = '".user_id()."' ";
      $sql.= "and etat = 0;";
      $db->query($sql);
      if($db->affected_rows() == 1) {
        session_unregister("user_group_id");
        user_group();
        $info_message = "Vous avez rsign de faire parti de ce groupe.";
        return;
      }

      if($tab_grp["optetat"] == 1) {
        $error_message = "Ce groupe est ferm aux dsinscriptions.";
        return ;
      }

      $sql = "delete from groupes_users where user_id = '".user_id()."';";
      $db->query($sql);

      $sql = "select * from groupes_users where group_id = '";
      $sql.= $tab_grp["group_id"]."' order by user_id asc;";
      $db->query($sql);
      /* Si il reste des utilisateurs dans ce groupe ... */
      if($db->affected_rows() != 0) {
        $info_message = "Vous avez quitt votre groupe.";
        $tab_users = $db->fetch_array(); 

        /* Si on tait le fondateur du groupe, alors on le donne au suivant
           sur la liste. */
        if($tab_grp["owner_id"] == user_id()) {
          $sql = "update groupes set owner_id = '".$tab_users["user_id"];
          $sql.= "' where group_id = '".$tab_grp["group_id"]."';";
          $db->query($sql);
        }

      } else { /* Sinon, on efface le groupe. */
        $info_message = "Vous avez quitt votre groupe. Il a t effac.";
        $sql = "delete from groupes where group_id = '".user_g_id()."';";
        $db->query($sql);

        /* Si on a valid un proejt, alors il faut le re-inistiliaser. */
        $sql = "update projets set validgrp = 0 where validgrp = '".user_g_id();
        $sql.= "';";
        $db->query($sql);
      }

      /* Il faut penser  "partir" du groupe pour le systme */
      session_unregister("user_group_id");
      user_group();
    }
  }

  /*
   * perso_info_edit
   * 
   * Changement de l'email et / ou du mot de passe de l'utilisateur.
   * Cette fonction est active quand on presse le bouton pour.
   */
  function perso_info_edit() {
    global $db;
    global $info_message, $error_message;

    if($_SERVER["REQUEST_METHOD"] == "POST"
    && isset($_POST["formulaire"])
    && $_POST["formulaire"] == "info_form") {
      $db->query("select * from users where username = '"
                 .$_SESSION["user_username"]."';");
      $tab = $db->fetch_array();

      $new_email = fp2txtsql($_POST["email"]);
      $new_pass1 = md5(fp2txtsql($_POST["password"]));
      $new_pass2 = md5(fp2txtsql($_POST["password_conf"]));

      if($tab["email"] != $new_email) {
        $sql = "update users set email = '".$new_email."' ";
        $sql.= "where username = '".$_SESSION["user_username"]."';";
        $db->query($sql);
        $info_message .= "Votre adresse email a t modifie.<br />";
      }

      if($new_pass1 != $new_pass2) {
        $error_message = "Les deux mots de passes rentrs ne coincident pas.";
      } else {
        if($tab["password"] == $new_pass1) {
          $error_message = "Le nouveau mot de passe est identique  l'ancien.";
        } else {
          $sql = "update users set password = '".$new_pass1."' ";
          $sql.= "where username = '".$_SESSION["user_username"]."';";
          $db->query($sql);
          $info_message .= "Votre mot de passe a t modifi !<br />";
        }
      }

      if($info_message == "" && $error_message == "") {
        $info_message = "Rien n'a t modifi !";
      }
    }
  }

  /*
   * perso_password_edit
   * 
   * Le responsable a press le bouton pour envoyer un mail  l'utilisateur
   * pour changer de mot de passe.
   * On gre le changement de mot de passe et l'envoit de l'email ici.
   */
  function perso_password_edit() {
    global $db;
    global $info_message, $error_message;

    if($_SERVER["REQUEST_METHOD"] == "POST"
    && isset($_POST["formulaire"]) 
    && $_POST["formulaire"] == "password_form") {

      /* Si le mot de passe entr est vide, alors on en gnre un. */
      $clr_password = fp2txtsql($_POST["password"]);
      $str_password = fp2txt($_POST["password"]); 

      if($clr_password == "")
        $str_password = $clr_password = user_generate_password();

      $nouveau_password = md5($clr_password);
      $utilisateur = fp2txtsql($_POST["password_sel"]);

      $sql = "update users set password = '".$nouveau_password."' ";
      $sql.= "where username = '".$utilisateur."';";

      $db->query($sql);

      /* Envoit d'un email */

      $sql     = "select * from users where username = '".$utilisateur."';";
      $db->query($sql);
      $tab     = $db->fetch_array();
      $to      = $tab["description"]. "<".$tab["email"].">";

      $to_nom  = $tab["description"]; 

      $sql     = "select * from users where username = '".$_SESSION["user_username"]."';";
      $db->query($sql);
      $tab     = $db->fetch_array();
      $from    = "From: ".$tab["description"]. "<".$tab["email"].">";

      $subject = "[TER]: Nouveau mot de passe pour $utilisateur.";
      $message = "Bonjour,\n\n";
      $message.= "Le mot de passe pour le compte \"$utilisateur\" ";
      $message.= "vient d'tre modifi.\n";
      $message.= "Voici donc votre nouveau mot de passe: \"$str_password\".";
      $message.= "\n\n"; 
      $message.= "A bientot sur le site web TER !\nLe responsable.\n";

      if(my_mail($to, $subject, $message, $from) == true) {
        $info_message = "L'email pour le changement du mot ";
        $info_message.= "de passe de $to_nom a bien t envoy.";
      } else {
        $error_message = "L'email pour le changement du mot ";
        $error_message.= "de passe de $to_nom n'a pas pu tre envoy.";
      }
    }
  }

  /*
   * perso_group_join
   *
   * XXX
   */
  function perso_group_join() {
    global $db, $info_message, $error_message;

    if(isset($_GET["joingroupe"]) == false)
      return;

    /* Si l'on fait dj parti d'un groupe, on ignore cette fonction. */
    if(user_g_id() != -1) {
      return;
    }

    $s_id = fp2txtsql($_GET["joingroupe"]);

    $sql = "select * from groupes where group_id = '$s_id';";

    $db->query($sql);
    $tab = $db->fetch_array();

    $sql = "insert into groupes_users(group_id, user_id, etat) ";
    $sql.= "values($s_id, ".user_id().", 0);";

    $db->query($sql);

    /* Envoit d'un message au crateur du groupe pour approuver. */

    $s_fromid = user_id();
    $s_toid = $tab["owner_id"]; 
    $s_fromhead = user_fromhead();
    $s_etat = 0;
    $s_objet = "Demande pour faire parti du groupe.";
    $s_texte = "L\'leve ".user_fromhead()." a demande pour faire parti du groupe.";

    $s_typemesg = 6;
    $s_dateenvoit = time();
    $s_miscinfo = $s_fromid;

    $sql = "insert into messages(fromid, toid, fromhead, etat, objet, ";
    $sql.= "texte, typemesg, dateenvoit, miscinfo) values(";
    $sql.= "'".$s_fromid."', ";
    $sql.= "'".$s_toid."', ";
    $sql.= "'".$s_fromhead."', ";
    $sql.= "'".$s_etat."', ";
    $sql.= "'".$s_objet."', ";
    $sql.= "'".$s_texte."', ";
    $sql.= "'".$s_typemesg."', ";
    $sql.= "'".$s_dateenvoit."', ";
    $sql.= "'".$s_miscinfo."');"; 

    $db->query($sql);

    $info_message = "Votre demande poure rejoindre le groupe XXX ";
    $info_message.= "a bien ete recue. <a href='javascript:history.go(-1)'>";
    $info_message.= "Retour a la page precedente.</a>";
  }

  /*
   * perso_group_create_edit
   *
   * XXX
   */
  function perso_group_create_edit() {
    global $db, $info_message, $error_message;

    /* Si l'on fait dj parti d'un groupe, on ignore cette fonction. */
    if(user_g_id() != -1) {
      return;
    }

    if($_SERVER["REQUEST_METHOD"] == "POST"
    && isset($_POST["formulaire"]) 
    && $_POST["formulaire"] == "group_form") {

      $s_titre = fp2htmlsql($_POST["group_nom"]);

      $sql = "select * from groupes where titre = '".$s_titre."';";

      $db->query($sql);
      if($db->affected_rows() != 0) {
        $error_message = "Ce nom de groupe est impossible.";
        return;
      } 

      $sql = "insert into groupes(titre, owner_id) ";
      $sql.= "values('".$s_titre."', ".user_id().");";

      $db->query($sql);

      if($db->affected_rows() == 1) {
        $info_message = "Votre groupe a bien ete cree.";

        $sql = "select group_id from groupes where owner_id = ".user_id().";";
        $db->query($sql);
        $tab = $db->fetch_array();

        $sql = "insert into groupes_users(group_id, user_id, etat) ";
        $sql.= "values(".$tab["group_id"].", ".user_id().", 1);";
        $db->query($sql);

        user_group();

      } else {
        $error_message = "La creation de votre groupe a genere une erreur.";
      }
    }
  }

  /*
   * perso_group_create_form
   *
   * XXX
   */
  function perso_group_create_form() {
?>
<br /><br />
<b>Creation d'un nouveau groupe:</b>
<br /><br />
<form action="?page=perso" method="post" name="group_form">
<input type="hidden" name="formulaire" value="group_form">
<table border="0">
<tr>
  <td>Nom du groupe:</td>
  <td><input type="text" name="group_nom" value="" /></td>
  <td><input type="submit" name="" value="Creer" /></td>
</tr>
</table>
</form>
<?
  }

  /*
   * perso_group_open_close
   *
   * Fonction qui traite si on doit ouvrir/fermer un groupe aux 
   * (des)inscriptions. 
   */
  function perso_group_open_close() {
    global $info_message, $error_message;
    global $db;

    if($_SERVER["REQUEST_METHOD"] == "GET") {
      if(isset($_GET["open"]) || isset($_GET["close"])) {
        $sql = "select * from groupes where group_id = '".user_g_id()."';";
        $db->query($sql);
        $tab_grp = $db->fetch_array();

        if($tab_grp["owner_id"] != user_id()) {
          $error_message = "Vous n'tes pas le responsable de ce groupe.";
          return;
        } 

        if(isset($_GET["close"]) == true) {
          $sql = "update groupes set optetat = 1 where group_id = '";
          $sql.= user_g_id()."';";
          $db->query($sql);
          $info_message = "Votre groupe est ferm aux inscriptions.";
        } else
          if(isset($_GET["open"]) == true) {
            $sql = "update groupes set optetat = 0 where group_id = '";
            $sql.= user_g_id()."';";
            $db->query($sql);
            $info_message = "Votre groupe est ouvert aux inscriptions.";
          }
      }
    }
  }

  /*
   * perso_group_valid
   */
  function perso_group_valid() {
    global $info_message, $error_message;
    global $db;

    if($_SERVER["REQUEST_METHOD"] == "GET"
    && isset($_GET["validgr"])) {
      $s_id = fp2txtsql($_GET["validgrp"]);

      $sql = "select * from groupes where group_id = '".user_g_id()."';";
      $db->query($sql);
      $tab_grp = $db->fetch_array();
      if($tab_grp["owner_id"] != user_id()) {
        $error_message = "Vous n'tes pas le responsable de ce groupe.";
        return;
      }

      $sql = "select * from groupes_users where user_id = '$s_id' ";
      $sql.= "and group_id = '".user_g_id()."' and etat = 0;";
      $db->query($sql);
      if($db->affected_rows() == 0) {
        $error_message = "Cet lve ne fait pas partis du groupe.";
        return;
      }

      $sql = "update groupes_users set etat = 1 where user_id = '$s_id' ";
      $sql.= "and group_id = '".user_g_id()."' and etat = 0;";
      $db->query($sql);

      $info_message = "Demande valide.";

      /* Envoit message */
      mesg_quick($s_id,
        "Acceptation dans le groupe ".user_g_titre(),
        "Vous avez t accept dans le groupe ".user_g_titre());
    }
  }

  /*
   * perso_group_assign
   *
   * XXX
   */
  function perso_group_assign() {
    global $info_message, $error_message;
    global $db;

    if($_SERVER["REQUEST_METHOD"] == "GET"
    && isset($_GET["assign"])) {
      $s_id = fp2txtsql($_GET["assign"]);
      if($s_id == user_id()) {
        $error_message = "Vous ne pouvez faire cela.";
        return ; 
      }
      $sql = "select * from groupes where group_id = '".user_g_id()."';";
      $db->query($sql);
      $tab_grp = $db->fetch_array();
      if($tab_grp["owner_id"] != user_id()) {
        $error_message = "Vous n'tes pas le responsable de ce groupe.";
        return;
      }

      $sql = "select * from groupes_users where user_id = '$s_id' ";
      $sql.= "and group_id = '".user_g_id()."';";
      $db->query($sql);
      if($db->affected_rows() == 0) {
        $error_message = "Cet lve ne fait pas partis du groupe.";
        return;
      }

      $sql = "select * from choix where user_id = '".user_id()."';"; 

      $db->query($sql);
      $tabchoix = $db->fetch_all_array();
      $numchoix = $db->affected_rows();

      for($i = 0; $i < $numchoix; $i ++) {
        $sql = "select * from choix where user_id = '".$s_id."' ";
        $sql.= "and projet_id = '".$tabchoix[$i]["projet_id"]."';"; 
        $db->query($sql);
        if($db->affected_rows() == 0) {
          $sql = "insert into choix(projet_id, user_id) ";
          $sql.= "values(".$tabchoix[$i]["projet_id"].", '$s_id');";
          $db->query($sql);
        }
      }

      /* XXX: envoyer un message en prcisant l'insertion de nouveaux choix */

      $sql = "update groupes set owner_id = $s_id where group_id = '".user_g_id()."';";
      $db->query($sql);

      $info_message = "Le changement de propritaire de groupe  bien eu lieu.";
    }
  }

  /*
   *
   */
  function perso_group_remove() {
    global $info_message, $error_message;
    global $db;

    if($_SERVER["REQUEST_METHOD"] == "GET"
    && isset($_GET["remove"])) {
      $s_id = fp2txtsql($_GET["remove"]);
      if($s_id == user_id()) {
        $error_message = "Vous ne pouvez faire cela.";
        return ; 
      }
      $sql = "select * from groupes where group_id = '".user_g_id()."';";
      $db->query($sql);
      $tab_grp = $db->fetch_array();
      if($tab_grp["owner_id"] != user_id()) {
        $error_message = "Vous n'tes pas le responsable de ce groupe.";
        return;
      }

      $sql = "delete from groupes_users where user_id = '".$s_id."';";
      $db->query($sql);
      if($db->affected_rows() == 1) {
        /* XXX: envoyer un message */
        $error_message = "Le membre du groupe a bien t supprim.";
      } else {
        $error_message = "Aucun membre du groupe n'a t supprim.";
      }
      
    }
  }

?>
