<?
  /* Script protection */

  if(function_exists("user_script_valid") == FALSE) {
    die(""); 
  } else {
    user_script_valid();
  }

  function selectform($nom, $prenom, $debut, $fin, $pad = 1, $def = -1) {
    echo "<select name='$prenom"."_"."$nom'>";
    for ($i = $debut; $i <= $fin; $i += $pad) {
      echo "<option value='$i'";
      if($def != -1 && $def == $i)
        echo " selected='selected'";
      echo ">$i</option>\n";
    }
    echo "</select>";
  }

  function reste_cnx($tab_creneau) {
    /* calcul combien il reste de crneau entre
      $tab_creneau["debut"] et $tab_creneau["fin"] */
    $i = 0;
    $u = $tab_creneau["debut"];
    while(($u = next_creneau($u)) <= $tab_creneau["fin"])
      $i ++;

    return($i);
  }

  /*
   * Soutenances
   */
  global $db, $info_message, $error_message;

  /* Parsage */
  if($_SESSION["user_level"] == 10) {

    if($_SERVER["REQUEST_METHOD"] == "POST"
    && isset($_POST["formulaire"])
    && $_POST["formulaire"] == "modprof") {

      $n_cren = fp2txtsql($_POST["nouv_creneau"]);
      $a_enca = fp2txtsql($_POST["encadrant"]);

      /* On vrifie combien de soutenances l'encadrant encadre. */

      $sql = "select debut,soutenances.id from soutenances, projets ";
      $sql.= "where projets.validgrp = soutenances.group_id ";
      $sql.= "and projets.id_auteur = $a_enca order by debut asc;";

      $db->query($sql);

      $num_sout = $db->affected_rows();
      $tab_sout = $db->fetch_all_array();

      $f_cren = $n_cren;
      /* On cherche la fin */
      for($i = 0; $i < $num_sout; $i ++) {
        $f_cren = next_creneau($f_cren);
      }

      /* On vrifie qu'il y a un crneau ou c'est possible. */

      $sql = "select * from sout_creneaux where debut <= $n_cren ";
      $sql.= "and fin >= $f_cren;";

      $db->query($sql);

      $num_possible = $db->affected_rows();

      if($num_possible == 1) {
        $sql = "select * from soutenances where debut >= $n_cren ";
	$sql.= "and debut < $f_cren;";

        $db->query($sql);

        $num_sout_presente = $db->affected_rows();

        if($num_sout_presente == 0) {
          $prochain = $n_cren;
          for($i = 0; $i < $num_sout; $i ++) {
            $sql = "update soutenances set debut = $prochain where ";
            $sql.= "id = ".$tab_sout[$i]["id"].";";

            $db->query($sql);
            $prochain = next_creneau($prochain);
          }
          $info_message = "Les soutenances ont t dplaces.";

        } else {
          $error_message = "Des soutenances sont prvues l o devraient aller certaines soutenances. Changements impossibles.";
        }
      } else {
        $error_message = "Les soutenances ne peuvent tre places ici.";
      }
    }

    if($_SERVER["REQUEST_METHOD"] == "POST"
    && isset($_POST["formulaire"])
    && $_POST["formulaire"] == "modsout") {

      $n_cren = fp2txtsql($_POST["nouv_creneau"]);
      $a_cren = fp2txtsql($_POST["lastsout"]);

      $sql = "update soutenances set debut = '$n_cren' where debut = '$a_cren';";
      $db->query($sql);
      $info_message = "Modification effectue.";

    }

    if($_SERVER["REQUEST_METHOD"] == "POST") {
      if(isset($_POST["formulaire"])
      && $_POST["formulaire"] == "form_ajout") {

        if(isset($_POST["nouv_groupe"]))
          $ajout_groupe = fp2txtsql($_POST["nouv_groupe"]);
        else
          $ajout_groupe = 0;

        if(isset($_POST["nouv_projsel"]))
          $ajout_projet = fp2txtsql($_POST["nouv_projsel"]);
        else
          $ajout_projet = "";

        if(isset($_POST["nouv_encadrant"]))
          $ajout_encadrant = fp2txtsql($_POST["nouv_encadrant"]);
        else
          $ajout_encadrant = "";

        if(isset($_POST["nouv_projet"]))
          $ajout_projet_nom = fp2txtsql($_POST["nouv_projet"]);
        else
          $ajout_projet_nom = "";

        if(isset($_POST["nouv_etudiant"]))
          $ajout_etudiants = fp2txtsql($_POST["nouv_etudiant"]);
        else
          $ajout_etudiants = "";

        if(isset($_POST["nouv_creneau"])) 
          $ajout_creneau = fp2txtsql($_POST["nouv_creneau"]);
        else
          $ajout_creneau = "";

        $ajout_etudiants = ereg_replace("\n", " - ", $ajout_etudiants);

        if($ajout_creneau != "") {

          $vartmp = "$ajout_projet:$ajout_encadrant:$ajout_projet_nom:$ajout_etudiants";

          if($ajout_groupe != 0) {
            $sql = "select * from projets where validgrp = '$ajout_groupe';";
            $db->query($sql);
            if($db->affected_rows() == 1)
              $vartmp = "";
          }

          $sql = "insert into soutenances(debut,group_id,contenu) values ('$ajout_creneau', '$ajout_groupe', '$vartmp');";

          $db->query($sql);
          $info_message = "Soutenance ajoute.";
        } else { 
          $error_message = "Pas de crneau. Peut tre faudrait-il en rajouter ?";
        }
      }
    }

    if($_SERVER["REQUEST_METHOD"] == "GET"
    && isset($_GET["act"])) {
      switch($_GET["act"]) {
        case "supprsout":
          if(isset($_GET["creneau"]) == false) 
            break;                                                                        $creneau = fp2txtsql($_GET["creneau"]);

          $sql = "delete from soutenances where debut = '$creneau';";
          $db->query($sql);
          if($db->affected_rows() == 1)
            $info_message = "Soutenance efface.";
          else
            $error_message = "Cette soutenance n'a pas pu tre efface.";
        break;
        case "supprimer":

          if(isset($_GET["creneau"]) == false)
            break;
          $creneau = fp2txtsql($_GET["creneau"]);

          /* On vrifie l'existance de ce crneau */
          $sql1 = "select * from sout_creneaux where debut = '$creneau';";
          $res1 = $db->query($sql1);
          if($db->affected_rows() == 0)
            break;
          $tab_res1 = $db->fetch_array();

          $sql2 = "delete from soutenances where debut >= ".$tab_res1["debut"];
          $sql2.= " and debut < ".$tab_res1["fin"].";";
          $res2 = $db->query($sql2);
          $number = $db->affected_rows();

          $sql3 = "delete from sout_creneaux where debut = '$creneau';";
          $res3 = $db->query($sql3);
          $info_message = "Ce crneau a t supprim.";
          if($number > 0) 
            $info_message.= " $number soutenance(s) prvue(s) a(ont) t supprime(s) de ce fait.";
        break;
        case "generer": /* Gnration prliminaire du calendrier des
                           soutenances */

          $sql = "select count(*) as nombre, id_auteur from projets where validgrp <> 0 group by id_auteur order by nombre desc;";
          $db->query($sql);
          $tab_encadrants = $db->fetch_all_array();
          $num_encadrants = $db->affected_rows();
          /* On a le tableau des encadrants qui ont des soutenances  faire,
             ordonn par le nombre dcroissants de soutenances */

          /* On va aussi avoir besoin des diffrents crneaux, supposs
             vide */
          $sql = "select * from sout_creneaux order by debut asc;";
          $db->query($sql);
          $tab_creneaux = $db->fetch_all_array();
          $num_creneaux = $db->affected_rows();

          /* Pour chaque encadrant, on va le mettre dans un seul crneau,
             si cela est possible */
          for($i = 0; $i < $num_encadrants; $i ++) {

            for($j = 0; $j < $num_creneaux; $j ++) {
              if(reste_cnx($tab_creneaux[$j]) >= $tab_encadrants[$i]["nombre"]){
                /* On place les soutenances de cet encadrant ici mme */
                $sql = "select * from projets where validgrp <> 0 and id_auteur = ".$tab_encadrants[$i]["id_auteur"].";";
                $db->query($sql);
                $tab_enca = $db->fetch_all_array();
                $num_enca = $db->affected_rows(); 
                for($k = 0; $k < $num_enca; $k ++) {
                  $sql = "insert into soutenances(debut, group_id, contenu) values('".$tab_creneaux[$j]["debut"]."', ".$tab_enca[$k]["validgrp"].", '');";
                  $sql = $db->query($sql);
                  $tab_creneaux[$j]["debut"] = next_creneau($tab_creneaux[$j]["debut"]);
                }
 
                break;
              }
            }
          }

          $sql = "select * from projets where validgrp <> 0 order by id_auteur";
          $db->query($sql);
          $tab_projs = $db->fetch_all_array();

        break;
      }

    }

    if($_SERVER["REQUEST_METHOD"] == "POST"
    && isset($_POST["formulaire"])
    && $_POST["formulaire"] == "ajout_cren") {
      $d_jour = fp2txtsql($_POST["deb_jour"]);
      $d_mois = fp2txtsql($_POST["deb_mois"]);
      $d_annee = fp2txtsql($_POST["deb_annee"]);
      $d_heure = fp2txtsql($_POST["deb_heure"]);
      $d_min = fp2txtsql($_POST["deb_min"]);

      $f_jour = fp2txtsql($_POST["deb_jour"]);
      $f_mois = fp2txtsql($_POST["deb_mois"]);
      $f_annee = fp2txtsql($_POST["deb_annee"]);
      $f_heure = fp2txtsql($_POST["fin_heure"]);
      $f_min = fp2txtsql($_POST["fin_min"]);

      $type_query = fp2txtsql($_POST["typequery"]);

      $d_n = sprintf("%04d%02d%02d%02d%02d", 
              $d_annee, $d_mois, $d_jour, $d_heure, $d_min);

      $f_n = sprintf("%04d%02d%02d%02d%02d",
              $f_annee, $f_mois, $f_jour, $f_heure, $f_min);

      if($d_n >= $f_n) {
        $error_message = "Impossible d'utiliser ce crneau.";
      } else {
        if($type_query == "ajouter") {
          /* On vrifie que ce crneau n'est pas dans un autre crneau */
          $sql = "select * from sout_creneaux order by debut asc;";
          $db->query($sql); 
          $err_find = 0;
          for($i = 0; $i < $db->affected_rows(); $i ++) {
            $tabrow = $db->fetch_array();
            if($d_n >= $tabrow["fin"] || $f_n <= $tabrow["debut"]) {
              continue;
            } else
              $err_find = 1;
          }
          if($err_find == 1) {
            $error_message = "Ce nouveau crneau est dj prsent en partie ou totalement dans les crneaux.";
          } else {
            $sql = "insert into sout_creneaux (debut, fin) values ($d_n, $f_n);";
            $db->query($sql);
            $info_message = "Nouveau crneau enregistr.";
          }
        } else { /* Modification d'un crneau */
          /* on rcupre l'ancien crneau */
          $sql = "select * from sout_creneaux where debut = '$type_query'";
          $db->query($sql);
          $tab = $db->fetch_array();

          /* on vrifie deja que le crneau n'est pas dj prsent */
          $sql = "select * from sout_creneaux order by debut asc;";
          $db->query($sql);
          $err_find = 0;
          for($i = 0; $i < $db->affected_rows(); $i ++) {
            $tabrow = $db->fetch_array();

            /* on va pas comparer le meme crneau :-) */
            if($tab["fin"] == $tabrow["fin"] 
            && $tab["debut"] == $tabrow["debut"])
              continue;
            if($d_n >= $tabrow["fin"] || $f_n <= $tabrow["debut"]) {
              continue;
            } else
              $err_find ++;
          }
          if($err_find >= 1) {
            $error_message = "Ce nouveau crneau est dj prsent en partie ou totalement dans les crneaux.";
          } else {
            /* on fait les modifs */
            $sql = "select * from soutenances where debut >= '$type_query' and debut < ".$tab["fin"].";"; 
            $db->query($sql);
            $tab_soutenances = $db->fetch_all_array();
            $num_soutenances = $db->affected_rows();
            $retire = 0;
            for($l = 0; $l < $num_soutenances; $l ++) {
              if($tab_soutenances[$l]["debut"] >= $d_n
              && $tab_soutenances[$l]["debut"] < $f_n) {
              } else {
                $sql = "delete from soutenances where id = ";
                $sql.= $tab_soutenances[$l]["id"].";";
                $db->query($sql);

                $retire ++;
              }
            }
            if($retire != 0) {
              $error_message = "Cette oppration a effac $retire soutenances.";
            }
            /* Fin de l'oppration */
            $sql = "delete from sout_creneaux where debut = ".$tab["debut"];
            $sql.= " and fin = ".$tab["fin"].";";
            $db->query($sql);

            $sql = "insert into sout_creneaux (debut, fin) ";
            $sql.= "values (".$d_n.", ".$f_n.");";
            $db->query($sql);

            $info_message = "Opration effectue";
          }
        }
      }
    }
  }

  /* Affichage */
  interface_add_anchor("Soutenances");
  echo "<b>Soutenances</b><br /><br />";

  if($_SESSION["user_level"] == 10) {
    $sql = "select * from soutenances order by debut asc;";
    $db->query($sql);
    $total_soutenance = $db->affected_rows();
    if($db->affected_rows() == 0) {
      echo "Il semble que la gnration initiale des soutenances n'a pas encore t effectue. Pour faire, <a href='?page=soutenance&amp;act=generer'>cliquer ce lien lancera cette procdure.</a>";
      echo "<br /><br />";
    }
  }

  $nombre_total = 0;
  $nombre_pris = 0;
  $placees = 0;

  $sql = "select * from sout_creneaux order by debut asc;";
  $db->query($sql);
  $num = $db->affected_rows();
  if($num == 0) {
    echo "Pas de crneaux rservs pour le moment pour les soutenances.";
    echo "<br /><br />";
  } else {
    $tab_rows = $db->fetch_all_array();
    for($i = 0; $i < $num; $i ++) {
      $tab_row = $tab_rows[$i];
      $u = $tab_row["debut"];
      $v = $tab_row["fin"];

      $sql = "select * from soutenances where debut >= $u and debut < $v order by debut asc;";
      $db->query($sql);
      $num_soutenances = $db->affected_rows();
      $tab_soutenances = $db->fetch_all_array();

      sscanf($u, "%04d%02d%02d%02d%02d",
        $d_annee, $d_mois, $d_jour, $d_heure, $d_min);

      sscanf($v, "%04d%02d%02d%02d%02d",
        $f_annee, $f_mois, $f_jour, $f_heure, $f_min);

      echo "<b>$d_jour/$d_mois/$d_annee</b>, de $d_heure:${d_min}0 ";
      echo " $f_heure:${f_min}0 ";
      if($_SESSION["user_level"] == 10) {
        echo "(<a href='?page=soutenance&amp;act=supprimer&amp;creneau=";
        echo $tab_row["debut"]."'>supprimer</a>)";

        echo ' - (<a href="#modifier" onclick="';
        echo 'ajout_cren.deb_jour.value=\''.$d_jour.'\';';
        echo 'ajout_cren.deb_mois.value=\''.$d_mois.'\';';
        echo 'ajout_cren.deb_annee.value=\''.$d_annee.'\';';
        echo 'ajout_cren.deb_heure.value=\''.$d_heure.'\';';
        echo 'ajout_cren.deb_min.value=\''.$d_min.'\';';
        echo 'ajout_cren.fin_heure.value=\''.$f_heure.'\';';
        echo 'ajout_cren.fin_min.value=\''.$f_min.'\';';
        echo 'ajout_cren.bouton.value=\'modifier\';';
        echo 'ajout_cren.typequery.value=\''.$u.'\';';
        echo '">modifier</a>)';
      }
      echo ":<br />\n";

      do {
        $ecrit = 0;
        sscanf($u, "%04d%02d%02d%02d%02d",
          $d_annee, $d_mois, $d_jour, $d_heure, $d_min);
        $heure = sprintf("%02d:%02d", $d_heure, $d_min);

        echo "&nbsp;-> <b>".$heure."</b>: ";
        if($placees < $num_soutenances)
          if($u == $tab_soutenances[$placees]["debut"]) {
            if($tab_soutenances[$placees]["contenu"] == "") {
              $sql = "select groupes.titre as nom_groupe, ";
              $sql.= "projets.titre as nom_projet, ";
              $sql.= "users.description as nom_encadrant ";
              $sql.= "from projets,users,groupes where validgrp = ";
              $sql.= $tab_soutenances[$placees]["group_id"];
              $sql.= " and projets.id_auteur = users.id ";
              $sql.= "and groupes.group_id = projets.validgrp;";
              $db->query($sql);
              $tab = $db->fetch_array();
              if($db->affected_rows() == 1) {
                echo "<b>" . $tab["nom_projet"] . "</b> encadr par <b>";
                echo $tab["nom_encadrant"] . "</b>";
                echo " (groupe ".$tab["nom_groupe"].")";
              } else {
                echo "groupe " . $tab_soutenances[$placees]["group_id"]; 
              }
/*
              if($tab_soutenances[$placees]["group_id"] != 0) {
                $sql = "select * from groupes_users,users where group_id = ";
                $sql.= $tab_soutenances[$placees]["group_id"];
                $sql.= " and groupes_users.user_id = users.id;";
                $db->query($sql);
                echo "<br />";
                for($z = 0; $z < $db->affected_rows(); $z++) {
                  $tabus = $db->fetch_array();
                  if($z) echo " - ";
                  echo $tabus["description"];
                }
              }
*/
            } else {
              if($tab_soutenances[$placees]["group_id"] != 0) {
                $sql = "select * from groupes where group_id = ";
                $sql.= $tab_soutenances[$placees]["group_id"];
                $db->query($sql);
                $tab = $db->fetch_array();
                $grp_nom = $tab["titre"]; 
              } else
                $grp_nom = "";

              $ret = preg_split("/:/", $tab_soutenances[$placees]["contenu"]);
              $projid = $ret[0];
              $enca = $ret[1];
              $projn = $ret[2];
              $etud = $ret[3];
              if($projid != "") {
                $sql = "select * from projets where id = '$projid';";
                $db->query($sql);
                $tab = $db->affected_rows();
                echo "Projet: <b>".$tab["titre"]."</b>; ";
              } else if($projn != "") {
                echo "<b>$projn</b>";
              }
              if($projid == "" && $enca != "")
                echo " encadr par <b>$enca</b>";
/*
              if($etud != "") {
                echo "<br />";
                $etud = preg_replace("/\n/", " - ", $etud);
                $etud = preg_replace("/ - $/", "", $etud);
                echo $etud;
              }
*/
              if($tab_soutenances[$placees]["group_id"] != 0) {
                echo " (groupe $grp_nom)";
/*
                $sql = "select * from groupes_users,users where group_id = ";
                $sql.= $tab_soutenances[$placees]["group_id"];
                $sql.= " and groupes_users.user_id = users.id;";
                $db->query($sql);
                echo "<br />";
                for($z = 0; $z < $db->affected_rows(); $z++) {
                  $tabus = $db->fetch_array();
                  if($z) echo " - ";
                  echo $tabus["description"];
                }
*/
              }
            }
            if($_SESSION["user_level"] == 10) {
              echo " - (<a href='?page=soutenance&amp;act=supprsout&amp;creneau=$u'>suppr</a>)";
              echo " - (<a href='?page=soutenance&amp;act=modsout&amp;creneau=$u'>modifier</a>)";
            }
            
            $placees ++;
          }

        echo "<br />\n";

        $nombre_total ++;

      } while(($u = next_creneau($u)) != $tab_row["fin"]);

      echo "<br />";
    }
  }

  echo "Nombre total de crneaux pour les soutenances: $nombre_total<br />";
  echo "Nombre total de crneaux libres/utiliss: ".($nombre_total - $placees)."/".$placees."<br />";
  echo "<a href='/sortieprn.php'>Liste imprimable avec les dtails...</a>";
  echo "<br /><br />";

  if($_SESSION["user_level"] == 10
  && isset($_GET["act"])
  && $_GET["act"] == "modsout") {
    interface_add_anchor("Modification soutenance(s)");
    echo "<b>Modification de soutenances</b><br /><br />";
    $anc_creneau = fp2txtsql($_GET["creneau"]);
    $sql = "select * from soutenances where debut = '$anc_creneau';"; 
    $db->query($sql);
    $tab_anc = $db->fetch_array();

    $encadrant = 0;

    if($tab_anc["group_id"] > 0) {
      $sql = "select * from projets where validgrp = ".$tab_anc["group_id"].";";
      $db->query($sql);
      if($db->affected_rows() == 1) {
        $tab_prj = $db->fetch_array();
        $encadrant = $tab_prj["id_auteur"];
      }
    }

    /* Dplacer tout les crneaux d'un soutenant */
    if($encadrant) {
      $sql = "select * from users where id = $encadrant;";
      $db->query($sql);
      $tab_encadrant = $db->fetch_array();
      echo "Dplacer les soutenances de ".$tab_encadrant["description"].":";
      echo "<br />";

      /* XXX */
?>                                                                              <form method="POST" action="?page=soutenance"> 
<input type="hidden" name="formulaire" value="modprof" />
<input type="hidden" name="encadrant" value="<? echo $encadrant; ?>">
<table border="1">
<tr>            
  <td>          
    Dplacer   
  </td>         
  <td>        
    <select name="nouv_creneau">
<?          
  $placees = 0;
  $sql = "select * from sout_creneaux order by debut asc;";
  $db->query($sql);
  $tab_creneaux = $db->fetch_all_array();
  $num_creneaux = $db->affected_rows();
  for($i = 0; $i < $num_creneaux; $i ++) {
    $tab_creneau = $tab_creneaux[$i];
    $u = $tab_creneau["debut"];
    $v = $tab_creneau["fin"];
    $sql = "select * from soutenances where debut >= $u and debut < $v order by debut asc;";
    $db->query($sql);
    $num_soutenances = $db->affected_rows();
    $tab_soutenances = $db->fetch_all_array();
    $placees = 0;

    sscanf($u, "%04d%02d%02d%02d%02d",
      $d_annee, $d_mois, $d_jour, $d_heure, $d_min);

    sscanf($v, "%04d%02d%02d%02d%02d",
      $f_annee, $f_mois, $f_jour, $f_heure, $f_min);

    do {
      $ecrit = 0;
      sscanf($u, "%04d%02d%02d%02d%02d",
        $d_annee, $d_mois, $d_jour, $d_heure, $d_min);
      $heure = sprintf("%02d:%02d", $d_heure, $d_min);


      if(($placees < $num_soutenances)
      && ($u == $tab_soutenances[$placees]["debut"])) {
        $placees ++;
      } else {
        echo "<option value='$u'>";
        echo sprintf("%2d:%02d le %2d/%02d", $d_heure, $d_min, $d_jour, $d_mois);
        echo "</option>";
      }
    } while(($u = next_creneau($u)) != $tab_creneau["fin"]);
  }
?>
    </select>
  </td>
</tr>
<tr>
  <td colspan="2" align="center">
    <input type="submit" value="modifier" />
  </td>
</tr>
</table>
</form>
<?
      echo "<br /><br />";
    }

    /* Dplacer une seule soutenance */ 
    sscanf($anc_creneau, "%04d%02d%02d%02d%02d",
           $d_annee, $d_mois, $d_jour, $d_heure, $d_min);

    $heure = sprintf("%02d:%02d", $d_heure, $d_min);
    echo "Dplacer la soutenance du <b>$d_jour/$d_mois  $heure</b><br />";
?>
<form method="POST" action="?page=soutenance">
<input type="hidden" name="formulaire" value="modsout" />
<input type="hidden" name="lastsout" value="<? echo $anc_creneau; ?>">
<table border="1">
<tr>
  <td>
    Dplacer 
  </td>
  <td>
    <select name="nouv_creneau">
<?
  $placees = 0;
  $sql = "select * from sout_creneaux order by debut asc;";
  $db->query($sql);
  $tab_creneaux = $db->fetch_all_array();
  $num_creneaux = $db->affected_rows();
  for($i = 0; $i < $num_creneaux; $i ++) {
    $tab_creneau = $tab_creneaux[$i];
    $u = $tab_creneau["debut"];
    $v = $tab_creneau["fin"];

    $sql = "select * from soutenances where debut >= $u and debut < $v order by debut asc;";
    $db->query($sql);
    $num_soutenances = $db->affected_rows();
    $tab_soutenances = $db->fetch_all_array();
    $placees = 0;

    sscanf($u, "%04d%02d%02d%02d%02d",
      $d_annee, $d_mois, $d_jour, $d_heure, $d_min);

    sscanf($v, "%04d%02d%02d%02d%02d",
      $f_annee, $f_mois, $f_jour, $f_heure, $f_min);

    do {
      $ecrit = 0;
      sscanf($u, "%04d%02d%02d%02d%02d",
        $d_annee, $d_mois, $d_jour, $d_heure, $d_min);
      $heure = sprintf("%02d:%02d", $d_heure, $d_min);


      if(($placees < $num_soutenances)
      && ($u == $tab_soutenances[$placees]["debut"])) {
        $placees ++;
      } else {
        echo "<option value='$u'>";
        echo sprintf("%2d:%02d le %2d/%02d", $d_heure, $d_min, $d_jour, $d_mois);
        echo "</option>";
      }
    } while(($u = next_creneau($u)) != $tab_creneau["fin"]);
  }
?>
    </select>
  </td>
</tr>
<tr>
  <td colspan="2" align="center">
    <input type="submit" value="modifier" />
  </td>
</tr>
</table>
</form>
<?
    echo "<br /><br />";
  }

  if($_SESSION["user_level"] == 10) { /* Ajouter des soutenances */
    interface_add_anchor("Ajout d'une soutenance");
    echo "<b>Ajout d'une soutenance</b><br /><br />";

    echo "Vous avez la possibilit de rajouter une soutenance pour un groupe existant ( l'exception que vous ne pouvez pas rajouter une soutenance pour un groupe en ayant dj une) ou de de crer une soutenance pour un projet/encadrant/lves ne se trouvant pas dans la base de donnes (grace aux champs de saisie suivant).<br /><br />\n";
?>
<form method="post" action="?page=soutenance">
<input type="hidden" name="formulaire" value="form_ajout" />
<table border="1">
<?
  $sql = "select group_id from soutenances where group_id <> 0;";
  $db->query($sql);
  $tab_u_grp = $db->fetch_all_array();
  for($i = 0; $i < $db->affected_rows(); $i ++) {
    $tab_u_grp_id[$i + 1] = $tab_u_grp[$i]["group_id"];
  }
  $sql = "select * from groupes;";
  $db->query($sql);
  $tab_grp = $db->fetch_all_array();

  if(count($tab_u_grp) < count($tab_grp)) {
?>
<tr>
  <td>Groupe</td>
  <td>
     <select name="nouv_groupe">
       <option value='0'>Aucun</option>
<?
     for($i = 0; $i < count($tab_grp); $i ++) {
       if(array_search($tab_grp[$i]['group_id'], $tab_u_grp_id) == false) {
         echo "<option value='".$tab_grp[$i]['group_id']."'>";
         echo $tab_grp[$i]['titre']."</option>";
       }
     }
?>
     </select>
  </td>
</tr>
<tr>
  <td colspan="2">Et/Ou:
  </td>
</tr>
<?
  }
?>
<?
  $sql = "select * from projets where valigdrp = 0";
  $db->query($sql);
  if($db->affected_rows() > 0) {
?>
<tr>
  <td>Projet</td>
  <td>
<?

    echo "<select name='nouv_projsel'>";
    for($i = 0; $i < $db->affected_rows(); $i ++) {
      $tab_prjprj = $db->fetch_array();
      echo "<option value='".$tab_prjprj["id"]."'>";
      echo $tab_prjprj["titre"];
      echo "</option>";
    } 
?>
  </td>
</tr>
<tr>
  <td colspan="2">Et/Ou:
  </td>
</tr>
<?
  }
?>
<tr>
  <td colspan="2">
    <table border="0">
      <tr>
        <td>
          Nom encadrant*
        </td>
        <td>
          <input type="text" name="nouv_encadrant" />
        </td>
      </tr>
      <tr>
        <td>
          Intitul projet*
        </td>
        <td>
          <input type="text" name="nouv_projet" />
        </td>
      </tr>
      <tr>
        <td>
          Etudiants concerns*
        </td>
        <td>
          <textarea name="nouv_etudiant" cols="20" rows="5"></textarea>
        </td>
      </tr>
    </table>
  </td>
</tr>
<tr>
  <td>
    Crneau
  </td>
  <td>
    <select name="nouv_creneau">
<?
  $placees = 0;
  $sql = "select * from sout_creneaux order by debut asc;";
  $db->query($sql);
  $tab_creneaux = $db->fetch_all_array();
  $num_creneaux = $db->affected_rows();
  for($i = 0; $i < $num_creneaux; $i ++) {
    $tab_creneau = $tab_creneaux[$i];
    $u = $tab_creneau["debut"];
    $v = $tab_creneau["fin"];

    $sql = "select * from soutenances where debut >= $u and debut < $v order by debut asc;";
    $db->query($sql);
    $num_soutenances = $db->affected_rows();
    $tab_soutenances = $db->fetch_all_array();
    $placees = 0;

    sscanf($u, "%04d%02d%02d%02d%02d",
      $d_annee, $d_mois, $d_jour, $d_heure, $d_min);

    sscanf($v, "%04d%02d%02d%02d%02d",
      $f_annee, $f_mois, $f_jour, $f_heure, $f_min);

    do {
      $ecrit = 0;
      sscanf($u, "%04d%02d%02d%02d%02d",
        $d_annee, $d_mois, $d_jour, $d_heure, $d_min);
      $heure = sprintf("%02d:%02d", $d_heure, $d_min);


      if(($placees < $num_soutenances)
      && ($u == $tab_soutenances[$placees]["debut"])) {
        $placees ++;
      } else {
        echo "<option value='$u'>";
        echo sprintf("%2d:%02d le %2d/%02d", $d_heure, $d_min, $d_jour, $d_mois);
        echo "</option>";
      }
    } while(($u = next_creneau($u)) != $tab_creneau["fin"]);
  }
?>
    </select>
  </td>
</tr>
<tr>
  <td colspan="2">
    <input type="submit" value="Enregistrer" />
  </td>
</tr>
</table>
</form>
<?

    echo "<br /><br />";
  }

  if($_SESSION["user_level"] == 10) { /* Dplacer des soutenances */
  }

  if($_SESSION["user_level"] == 10) { /* Responsable du module */
    interface_add_anchor("Nouveau crneau");
    echo "<a name='modifier' />";
    echo "<b>Nouveau crneau</b><br /><br />";

?>
<table border="0">
<tr>
<td>
<form action="?page=soutenance" method="post" name="ajout_cren">
<input type="hidden" name="formulaire" value="ajout_cren" />
<input type="hidden" name="typequery" value="ajouter" />
<table border="1">
<tr>
  <td>&nbsp;</td>
  <td>jour</td>
  <td>mois</td>
  <td>anne</td>
  <td>heure</td>
  <td>min</td>
</tr>
<?
  $nowtab = getdate(time()); 
?>
<tr>
  <td>Dbut</td>
  <td><? selectform("jour", "deb", 1, 31, 1, $nowtab["mday"]); ?></td>
  <td><? selectform("mois", "deb", 1, 12, 1, $nowtab["mon"]); ?></td>
  <td><? selectform("annee", "deb", 2001, 2099, 1, $nowtab["year"]); ?></td>
  <td><? selectform("heure", "deb", 0, 24, 1, $nowtab["hours"]); ?></td>
  <td><? selectform("min", "deb", 0, 59, 30); ?></td>
</tr>
<tr>
  <td>Fin</td>
  <td colspan="3">&nbsp;</td>
  <td><? selectform("heure", "fin", 0, 24, 1, $nowtab["hours"] + 1); ?></td>
  <td><? selectform("min", "fin", 0, 59, 30); ?></td>
</tr>
<tr>
  <td colspan="3" align="center">
    <input type="submit" name="bouton" value="ajouter" />
  </td>
  <td colspan="3" align="center">
    <input type="button" value="effacer" onclick="ajout_cren.bouton.value='ajouter';ajout_cren.typequery.value='ajouter' "/>
</tr>
</table>
</form>
</td>
</tr>
</table>
<?
  }

?>
