<?
  /* Script protection */

  if(function_exists("user_script_valid") == FALSE) {
    die(""); 
  } else {
    user_script_valid();
  }

  /*
   * encradrer_projet_listing
   *
   * Listing des projets. 
   */
  function encradrer_projet_listing() {
    global $error_message;
    global $db, $modules;;

    if(isset($_GET["voir"])) {
      $voir = fp2txtsql($_GET["voir"]);
    } else {
      $voir = -1;
    }

    if($voir != -1) {
      $db->query("select * from projets where id_auteur = ".user_id().
                 " and id = $voir");

      if($db->affected_rows() != 1) {
        $error_message = "Ce projet ne semble pas tre le votre. ";
        $error_message.= "Pour voir les autres projets, <a href='?page=projets'>cliquez ici</a>";
      } else { /* Voir enfin le projet */
        voir_projet($voir);
      }
    }
?>
<? interface_add_anchor("Les projets encadrs"); ?>
<b>Les projets que vous encadrez:</b>
<br /><br />
<?
   $db->query("select * from projets where id_auteur = ".user_id().";");

   $num_row = $db->affected_rows();

   if($num_row == 0) {
     echo "Vous n'encadrez <b>aucun</b> projet.<br />";
     return;
   }

   $tab = $db->fetch_all_array();
   for($i = 0; $i < $num_row; $i ++) {
     voir_projet($tab[$i]["id"]);
   }
  }

  /*
   * encadrer_projet_devalider
   *
   * Cette fonction est appelle si le projet est a devalider.
   */
  function encadrer_projet_devalidation() { 
    global $db; 
    global $info_message, $error_message;

    if($_SERVER["REQUEST_METHOD"] != "GET"
    || isset($_GET["devalider"]) == false)
      return ;
 
    $s_gid = fp2txtsql($_GET["devalider"]);

    $sql = "select * from projets where id_auteur = '".user_id();
    $sql.= "' and validgrp = '$s_gid';";

    $db->query($sql);
    $num = $db->affected_rows();
 
    if($num != 1) {
      $error_message = "Vous ne pouvez pas dvalider ce projet.";
      return ;
    }

    $sql = "update projets set validgrp = 0 where validgrp = '$s_gid';";
    $db->query($sql);
    $num = $db->affected_rows();

    if($num == 1) {
      $info_message = "Le projet a t retir  ces tudiants.";
    } else {
      $error_message = "Une erreur est intervenue.";
    } 

    return ;
  }

  /*
   * encadrer_projet_valider
   *
   * Cette fonction est appelle si le projet est valide par l'encadrant
   * pour un groupe.
   */
  function encadrer_projet_validation() {
    global $db;
    global $info_message, $error_message;

    if($_SERVER["REQUEST_METHOD"] != "GET"
    || isset($_GET["valider"]) == false)
      return ;

    $s_gid = fp2txtsql($_GET["valider"]);
    $s_proj = fp2txtsql($_GET["projet"]);

    $sql = "select * from groupes where group_id = '$s_gid';";
    $db->query($sql);
    if($db->affected_rows() != 1) {
      $error_message = "Ce groupe n'existe pas.";
      return ;
    } else {
      $tab = $db->fetch_array();
      $grp_titre = $tab["titre"];
    }

    /* Verifications: le groupe n'a pas valide d'autre projet. */
    $sql = "select * from projets where validgrp = '$s_gid';";
    $db->query($sql);
    if($db->affected_rows() >= 1) {
      $tabgrp = $db->fetch_array();
      $error_message = "Le groupe selectionn (".$grp_titre;
      $error_message.= ") a dj un projet (".$tabgrp["titre"].")";
      return ;
    }

    /* Verifications: ce projet n'est pas deja pris */
    $sql = "select * from projets where id = '$s_proj' and validgrp <> 0;";
    $db->query($sql);
    if($db->affected_rows() == 1) {
      $error_message = "Il semble que ce projet a dj t valid.";
      return ;
    }

    /* Inscription: */
    $sql = "update projets set validgrp = '$s_gid' where id = '$s_proj';";
    $db->query($sql);
    if($db->affected_rows() == 1) {
      $info_message = "Le projet a bien t valid !";
      $sql = "select * from groupes_users where group_id = '$s_gid';";
      $db->query($sql);
      $tab_users = $db->fetch_all_array();
      $num_users = $db->affected_rows();
      for($i = 0; $i < $num_users; $i ++) {
        $tab_user = $tab_users[$i];

        $sql = "select * from projets where id = '$s_proj';";
        $db->query($sql);
        $tab = $db->affected_rows();

        $mesg = "Le projet '<b>".$tab["titre"]."</b>' vient d'tre";
        $mesg.= " valid pour votre groupe.";

        mesg_quick($tab_user["user_id"], "Validation du projet", $mesg); 
      }
    } else {
      $error_message = "Une erreur (grave ?) a eu lieu. Il est peut etre temps de contacter le developpeur de ce produit.";
      return;
    }

    return ;
  }

  /*
   * encadrer_projet_ajout_edit
   *
   * Encadrement d'un nouveau projet: Enregistrement.
   */
  function encadrer_projet_ajout_edit() {
    global $db;
    global $info_message;

    if($_SERVER["REQUEST_METHOD"] == "POST"
    && isset($_POST["formulaire"]) == true
    && $_POST["formulaire"] == "p_ajout") {

      $s_titre = fp2txtsql($_POST["proj_titre"]);
      $s_type  = fp2txtsql($_POST["proj_type"]);
      $s_info  = fp2htmlsql($_POST["proj_info"]);
      $s_taille = fp2txtsql($_POST["proj_taille"]);

      $s_modules = "";

      foreach($_POST as $idx => $vidx) {
        if(ereg("mod_", $idx)) {
          $s_modules .= ereg_replace("mod_", "", $idx)." ";
        }
      }

      if(isset($_POST["p_modif"])) { /* Modification */
        $id = fp2txtsql($_POST["p_modif"]);

        $sql = "update projets set ";
        $sql.= "titre = '$s_titre', ";
        $sql.= "info = '$s_info', ";
        /* $sql.= "id_auteur = ".user_id().", "; */
        $sql.= "typeproj = '$s_type', ";
        $sql.= "module = '$s_modules', ";
        $sql.= "tailleq = '$s_taille' ";
        $sql.= "where id = $id;";

        $db->query($sql);

        $info_message = "Votre projet a bien t modifi. Merci !";
      } else { /* Ajout */
        $sql = "insert into projets(titre, info, id_auteur, typeproj, ";
        $sql.= "module, tailleq, validgrp) values('$s_titre', '$s_info', ";
        $sql.= user_id().", '".$s_type."', '".$s_modules."', '$s_taille', 0);"; 

        $db->query($sql);
        $info_message = "Votre projet a bien t enregistr. Merci !";
      }
    }
  }

  function encadrer_projet_modif_effacer() {
    global $modules, $type_proj;
    global $db, $info_message;

    /* Pour la suppresion */
    if(isset($_GET["effacer"])) {
      $id = fp2txtsql($_GET["effacer"]);
      
      if($_SESSION["user_level"] == 5) { 
        $sql = "select * from projets where id = '$id' ";
        $sql.= "and id_auteur = '".user_id()."';";
        $db->query($sql);
      } else if($_SESSION["user_level"] == 10) {
        $sql = "select * from projets where id = '$id';";
        $db->query($sql);
      }
      
      if($db->affected_rows() == 1) {
        $tab = $db->fetch_array();
        $mesg = "<font color='red'>";
        $mesg.= "Vous avez demandez  effacer le projet \"";
        $mesg.=  $tab["titre"] . "\".</font><br/>"; 
        $mesg.= "<a href='?page=encadrer&amp;effacerconf=";
        $mesg.= $tab["id"]."'>Cliquez ici pour valider votre demande</a>";
        echo $mesg;
        echo "<br /><br />";
        $info_message = $mesg;
      }
    }

    /* Pour la suppression */
    if(isset($_GET["effacerconf"])) {
      $id = fp2txtsql($_GET["effacerconf"]);

      if($_SESSION["user_level"] == 5) { 
        $sql = "select * from projets where id = '$id' ";
        $sql.= "and id_auteur = '".user_id()."';";
        $db->query($sql);
      } else if($_SESSION["user_level"] == 10) {
        $sql = "select * from projets where id = '$id';";
        $db->query($sql);
      }

      if($db->affected_rows() == 1) {
        $sql = "delete from projets where id = '$id';";
        $db->query($sql);
        $sql = "delete from choix where projet_id = '$id';";
        $db->query($sql);

        $info_message = "Votre projet a t effac.";
      } else {
        $id = -1;
        $error_message = "Vous ne pouvez pas effacer ce projet.";
      }
    }
  }

  /*
   * encadrer_projet_modif_effacer
   *
   * XXX 
   */
  function encadrer_projet_ajout_form () {
    global $modules, $type_proj;
    global $db;

    /* Pour la modification */
    if(isset($_GET["modifier"])) {
      $id = fp2txtsql($_GET["modifier"]);

      if($_SESSION["user_level"] == 5) {
        $sql = "select * from projets where id = '$id' ";
        $sql.= "and id_auteur = '".user_id()."';";
        $db->query($sql);
      } else if($_SESSION["user_level"] == 10) {
        $sql = "select * from projets where id = '$id';";
        $db->query($sql);
      }

      $num = $db->affected_rows();

      if($num == 1) {
        $tab = $db->fetch_array();
      } else {
        $id = -1;
        $error_message = "Vous pouvez pas faire de modification sur ce projet.";
      }
    } else {
      $id = -1;
      $error_message = "Vous pouvez pas faire de modification sur ce projet.";
    }

?>
<br /><br />
<a name='modifier' />
<? interface_add_anchor("Nouveau projet"); ?>
<b>Encadrer un nouveau projet:</b>
<br /><br />
<?      
  if($id != -1) {
    /* Si on effectue un ajout, alors on re-remplira les boites apres
       modification. */
    echo '<form action="?page=encadrer&amp;modifier='.$id;
    echo '" method="post" name="p_ajout">';
  } else { /* Ajout */
    echo '<form action="?page=encadrer" method="post" name="p_ajout">';
  }
?>
<input type="hidden" name="formulaire" value="p_ajout" />
<?
  if($id != -1) {
    echo '<input type="hidden" name="p_modif" value="'.$id.'">';
  }
?>
<table border="0">
<tr>
  <td><b>Titre</b>:</td>
  <td><input type="text" name="proj_titre" size="45" value="<?
  if($id != -1) {
    echo $tab["titre"];
  }
?>"/></td>
</tr>
<tr>
  <td><b>Type</b>:</td>
  <td>
    <select name="proj_type">
<?
  foreach($type_proj as $idx => $vidx) {
    echo "<option value=\"$idx\"";
    if($id != -1) {
      if($idx == $tab["typeproj"])
        echo " selected";
    }
    echo ">".$vidx."</option>";
  }
?>
    </select>
  </td>
</tr>
<tr>
  <td colspan="2"><b>Informations/intitul</b>:</td>
</tr>
<tr>
  <td colspan="2">
    <textarea name="proj_info" cols="60" rows="7"><?
  if($id != -1) {
    echo $tab["info"];
  }
?></textarea>
  </td>
</tr>
<tr>
  <td><b>Taille quipe</b>:</td>
  <td><input type="text" name="proj_taille" size="10" value="<?
  if($id != -1) {
    echo $tab["tailleq"];
  }
?>"/></td>
</tr>
<tr>
  <td colspan="2">
  <b>Modules concerns:</b><br />
    <table border="1"> 
<?
    if($id != -1) {
      $sel_modules = explode(" ", $tab["module"]);
    }

    $col = 1;
    foreach($modules as $idx => $vidx) {
      if($col) {
        $col = 0;
        echo "<tr><td>";
        echo "<input type=\"checkbox\" name=\"mod_$idx\""; 
        if($id != -1) {
          if(in_array("$idx", $sel_modules)) {
            echo " checked";
          }
        }
        echo "/>";
        echo "(mod: $idx) ".$vidx;
        echo "</td>\n";
      } else {
        $col = 1;
        echo "<td>";
        echo "<input type=\"checkbox\" name=\"mod_$idx\"";
        if($id != -1) {
          if(in_array("$idx", $sel_modules)) {
            echo " checked";
          }
        }
        echo "/>";
        echo "(mod: $idx) ".$vidx;
        echo "</td></tr>\n";
      }
    }
    if($col == 0) {
      echo "<td>&nbsp;</td></tr>";
    }
?>
    </table>
  </td>
<tr>
  <td colspan="2">
    <input type="submit" name="proj_button" value="<?
  if($id == -1) {
    echo "Ajout";
  } else {
    echo "Modifier";
  }
?>" />
  </td>
</tr>
</table>
<?
  }

  /* 1ere etape: parsing */
  encadrer_projet_validation();
  encadrer_projet_devalidation();
  encadrer_projet_ajout_edit();
  encadrer_projet_modif_effacer();

  /* 2nde etape: affichage */

  /* Listing des projets */
  encradrer_projet_listing();

  encadrer_projet_ajout_form();
?>
