<?
  /* fonctions pour les encadrants / etudiants */

  function ee_parsing($type) {
    global $info_message, $error_message;
    global $db;
    global $ter_location;

    if($type != 1 && $type != 5) {
      $error_message = "Impossible de faire cette modification.";
    }

    /* Ajout (On diffrencie ajout de modifier par _POST["modifier_login"] */
    if($_SERVER["REQUEST_METHOD"] == "POST") {

      /* Partie commune  l'ajout et la modification (I/O des formulaires) */
      if($_POST["formulaire"] == "ajout_form") {
        /* Pour l'ajout d'un utilisateur, on dispose d'un nom, d'un prnom et
         * d'une adresse email. 
         * Il est possible d'avoir un login, et dans ce cas l, on ne gnrera
         * pas le login  partir de la 1ere partie de l'adresse email.
         */

        /* les variables s_*** sont les variables sql-ready */
        /* les variables t_*** sont les variables txt-ready (email) */
        /* les variables h_*** sont les variables html-ready (website) */
        $s_email  = fp2txtsql($_POST["email"]);
        $s_login  = fp2txtsql($_POST["login"]);
        $s_nom    = fp2txtsql($_POST["nom"]);
        $s_prenom = fp2txtsql($_POST["prenom"]);
        $s_password = fp2txtsql($_POST["password"]);

        $s_login_mod = fp2txtsql($_POST["modifier_login"]);
        $t_login_mod = fp2txt($_POST["modifier_login"]);

        $t_email  = fp2txt($_POST["email"]);
        $t_login  = fp2txt($_POST["login"]);
        $t_nom    = fp2txt($_POST["nom"]);
        $t_prenom = fp2txt($_POST["prenom"]);
        $t_password = fp2txt($_POST["password"]);

        if($s_login != "" && $_POST["modifier_login"] == "")
          if(preg_match('/^[#$&*0-9A-Za-z^_`a-z{|}~]+$/', $s_login) == false) {
            $error_message = "Le login entr (".fp2txt($s_login).") contient ";
            $error_message.= "des caractres incorrects.";
            return;
          }

        if(is_email($s_email) == false) {
          $error_message = "L'adresse email est invalide.";
          return;
        }

        if($s_nom == "" || $s_prenom == "") {
          $error_message = "Le nom et/ou prnom est vide.";
          return;
        }

        if($s_login == "") {
          if(ereg("([^@].*)@(.*)", $s_email, $resultat) == true) {
            $s_login = $resultat[1]; 
            ereg("([^@].*)@(.*)", $t_email, $resultat);
            $t_login = $resultat[1]; 
          } else {
            $t_login = $s_login = user_generate_login();
          }
        }

        /* On boucle jusqu' avoir un login ok */
        while(user_is_login_free($s_login) == false) {
          $t_login = $s_login = user_generate_login();
        }

        /* On a un login unique. */

        if($s_password == "" && $s_login_mod == "")
          $t_password = $s_password = user_generate_password();

        /* 
         * Il ne reste plus qu' bien former le nom/prnom en
         * "NOM Prenom", et entrer tout cela dans la base.
         */

        /* Version SQL */
        $s_nom_final = strtoupper($s_nom);
        $s_prenom_final = strtoupper($s_prenom[0]);
        $s_prenom_final.= substr(strtolower($s_prenom), 1, strlen($s_prenom) - 1);

        $s_description = $s_nom_final . " " . $s_prenom_final;

        /* Version Texte/html */
        $t_nom_final = strtoupper($t_nom);
        $t_prenom_final = strtoupper($t_prenom[0]);
        $t_prenom_final.= substr(strtolower($t_prenom), 1, strlen($t_prenom) - 1);

        $t_description = $t_nom_final . " " . $t_prenom_final;
      } /* Fin partie commune */

      /* Partie spcifique: AJOUT */
      if($_POST["formulaire"] == "ajout_form"
      &&($_POST["modifier_login"] == "")) {

        $sql = "INSERT INTO users ";
        $sql.= "(username, password, description, email, level) ";
        $sql.= "values('".$s_login."', '".md5($s_password)."', ";
        $sql.= "'".$s_description."', '".$s_email."', $type);";
        $db->query($sql);

        if(isset($_POST["invalidemail"])
        && $_POST["invalidemail"] != "") {
          $sidmesg = fp2txtsql($_POST["invalidemail"]);
          $sql = "update messages set etat = 3 where id = '".$sidmesg."';";
          $db->query($sql);
        }

        if($type == 1)
          $info_message = "Nouvel etudiant:<br /><b>" . $t_description;
        else
          $info_message = "Nouvel encadrant:<br /><b>" . $t_description;

        $info_message.= "</b><br />";
        $info_message.= "(login: <b>$t_login</b>)<br />";

        /* Envoit d'un email ... */

        $to      = $t_description . "<".$t_email.">";
        $s = ereg_replace("&lt;", "<", user_fromhead());
        $s = ereg_replace("&gt;", ">", $s);
        $from    = "From: " . $s;

        $subject = "[TER]: Nouveau compte sur le site TER";
        $message = "Bonjour,\n\n";
        $message.= "Un compte sur le site TER vient de vous tre attribu:\n";
        $message.= "Voici donc vos identifiants:\n\n";
        $message.= "Login: ".$t_login."\n";
        $message.= "Mot de passe: ".$t_password."\n";
        $message.= "Site TER: $ter_location";
        $message.= "\n\n"; 
        $message.= "A bientot sur le site web TER !\nLe responsable.\n";

        if(my_mail($to, $subject, $message, $from) == true) {
          $info_message.= "Mail envoy  $t_email !";
        } else {
          $error_message = "Le mail n'a pas pu tre envoy.";
        }
      } /* Fin partie specifique: ajout */

      /* Partie spcifique: MODIFICATION */
      if($_POST["formulaire"] == "ajout_form"
      &&($_POST["modifier_login"] != "")) {

        $sql = "UPDATE users set ";
        if($s_password != "")
          $sql.= "password = '".md5($s_password)."', ";
        $sql.= "description = '".$s_description."', ";
        $sql.= "email = '".$s_email."' ";
        $sql.= "where username = '".$s_login_mod."';";

        $db->query($sql);

        $info_message = "Les modifications ont t prises en compte.<br />";

        /* Le mot de passe a t modifi. Il faut en prvenir l'utilisateur. */
        if($s_password != "") {
          $sql     = "select * from users where username = '".$s_login_mod."';";
          $db->query($sql);
          $tab     = $db->fetch_array();
          $to      = $tab["description"]. "<".$tab["email"].">";

          $to_nom  = $tab["description"]; 

          $sql     = "select * from users where username = '";
          $sql    .= $_SESSION["user_username"]."';";
          $db->query($sql);
          $tab     = $db->fetch_array();
          $from    = "From: ".$tab["description"]. "<".$tab["email"].">";

          $subject = "[TER]: Nouveau mot de passe pour $t_login_mod.";
          $message = "Bonjour,\n\n";
          $message.= "Le mot de passe pour le compte \"$t_login_mod\" ";
          $message.= "vient d'tre modifi.\n";
          $message.= "Voici donc votre nouveau mot de passe: \"$t_password\".";
          $message.= "\n\n"; 
          $message.= "A bientot sur le site web TER !\nLe responsable.\n";

          if(my_mail($to, $subject, $message, $from) == true) {
            $info_message.= "L'email pour le changement du mot ";
            $info_message.= "de passe de $to_nom a bien t envoy.";
          } else {
            $error_message = "L'email pour le changement du mot ";
            $error_message.= "de passe de $to_nom n'a pas pu tre envoy.";
          }
        }
      } /* Fin partie spcifique: Modification */
    } /* Fin si methode == POST */
  } /* Fin fonction ee_parsing */ 

  function encadrants_parsing() {
    ee_parsing(5);
  }

  function etudiants_parsing() {
    ee_parsing(1);
  }

  /* Voir les dtails d'un projet */
  /* Cette fonction est utilise dans l'espace encadrant et 
     pour les tudiants */
  function voir_projet($voir_id = "") {
    global $db, $modules;
    global $type_proj;

    if($voir_id == "") 
      $voir_id = fp2txtsql($_REQUEST["id"]);

    if($voir_id != "") {
      $sql = "select projets.id as projet_id,description,email,titre,typeproj,info,tailleq,validgrp,module,id_auteur ";
      $sql.= "from projets,users where projets.id = '$voir_id' and projets.id_auteur = users.id;";
      $db->query($sql);
      if($db->affected_rows() == 1) {
        $tab = $db->fetch_array();

        echo "<table width='100%' cellpadding='3' cellspacing='1' border='0'>\n";
        echo "<tr>\n";
        echo "<td title='Numero du sujet' bgcolor='#EEEEFF' width='5%' align='center'>\n";
        echo "<font size='2'>\n";
        echo $tab["projet_id"];
        echo "</font></td>\n";
        echo "<td bgcolor='#08119A' width='95%'>\n";
        echo "<table width='100%'>\n";
        echo "<tr>\n";
        echo "<td width='20%' align='center'><font size='2'>\n";
        echo "<a title='Contacter l encadrant' class='mail' href=mailto:";
        echo $tab["email"];
        echo "?subject=[TER] Projet: ";
        echo $tab["titre"]."'>";
        echo "<b>";
        echo $tab["description"];
        echo "</b></a></font>";
        echo "</td>";
        echo "<td width='70%' align='center'>";
        echo "<font title='Titre du sujet' size='2' color='#ffffff'>";
        echo "<b>";
        echo $tab["titre"];
        echo "</b>";
        echo "</font>";
        echo "</td>";
        echo "<td width='10%' align='right'>";
        echo "</td></tr>";
        echo "</table>";
        echo "</td>";
        echo "</tr>";

        echo "<tr>";
        echo "<td bgcolor='lightblue' width='5%' align='center'>";
        echo "<font size='2'><b>Nature</b></font></td>";
        echo "<td bgcolor='#EEEEFF' width='95%'><font size='2'>";
        foreach($type_proj as $idx => $cont) {
          if($idx == $tab["typeproj"])
            echo $cont;
        }
        echo "</font></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td bgcolor='lightblue' width='5%' align='center'>";
        echo "<font size='2'><b>Th&egrave;me</b></font></td>";
        echo "<td bgcolor='#EEEEFF' width='95%'><font size='2'>";
        echo "<p align='justify'>";
        echo txt2htmloutput($tab["info"]);
        echo "</p></font></td>";
        echo "</tr>";

        echo "<tr>";
        echo "<td bgcolor='lightblue' width='5%' align='center'>";
        echo "<font size='2'><b>Taille de l'&eacute;quipe</b></font></td>";
        echo "<td bgcolor='#EEEEFF' width='95%'><font size='2'>";
        echo $tab["tailleq"];
        echo "</font></td>";
        echo "</tr>";

        echo "<tr>";
        echo "<td bgcolor='lightblue' width='5%' align='center'>";
        echo "<font size='2'><b>Module concern&eacute;</b></font></td>";
        echo "<td bgcolor='#EEEEFF' width='95%'><font size='2'>";
        $module = explode(" ", $tab["module"]);
        foreach($module as $idx) {
        if($idx != "")
          echo "<b>$idx</b> - ".$modules["$idx"]."<br />";
        else
          echo "Aucun.<br />";
        }
        echo "</font></td>";
        echo "</tr>";

        if($tab["id_auteur"] == user_id() || $_SESSION["user_level"] == 10) {
          echo "<td bgcolor='lightblue' width='5%' align='center'>";
          echo "<font size='2'><b>Administration</b></font></td>";
          echo "<td bgcolor='#EEEEFF' width='95%'><font size='2'>";
          echo "<a href='?page=encadrer&amp;modifier=".$tab["projet_id"];
          echo "#modifier'>";
          echo "Modifier</a> - ";
          echo "<a href='?page=encadrer&amp;effacer=".$tab["projet_id"]."'>";
          echo "Effacer</a>";
          echo "</td></tr>";
        }

        $monchoix = 0;
        /* Si le projet est valid, alors $tab["validgrp"] == id grp */
        if($tab["validgrp"] != 0) {
          echo "<tr>";
          echo "<td bgcolor='lightblue' width='5%' align='center'>";
          echo "<font size='2'><b>Validation</b></font></td>";
          echo "<td bgcolor='#EEEEFF' width='95%'><font size='2'>";

          $sql = "select * from users, groupes, groupes_users where groupes.group_id = '".$tab["validgrp"]."' and groupes_users.group_id = groupes.group_id and groupes_users.user_id = users.id and groupes_users.etat = 1;";
          $db->query($sql);
          $num = $db->affected_rows();
          $tabgrp = $db->fetch_all_array();
          echo "Projet valid pour le groupe <b>".$tabgrp[0]["titre"]."</b>";
          if($_SESSION["user_level"] >= 5 && user_id() == $tab["id_auteur"]) {
            echo "&nbsp;";
            echo "(<a href='?page=encadrer&amp;devalider=".$tab["validgrp"]."'>Retirer la validation</a> pour ce groupe)";
          }
          echo "<br />";
          echo "Ce groupe est compos de:<br />";
          for($i = 0; $i < $num; $i++) {
            echo "* <a href='mailto:".$tabgrp[$i]["email"]."'>";
            echo $tabgrp[$i]["description"];
            echo "</a>";
          }

          echo "</font></td>";
          echo "</tr>";
          echo "<tr>";
          echo "<td bgcolor='lightblue' width='5%' align='center'>";
          echo "<font size='2'><b>Choix</b></font></td>";
          echo "<td bgcolor='red' width='95%'><font size='2'>";
          echo "Projet valid !";
          echo "</td></tr>";

          if($tab["id_auteur"] == user_id() 
          || $tab["validgrp"] == user_g_id()) {
            echo "<tr>";
            echo "<td bgcolor='lightblue' width='5%' align='center'>";
            echo "<font size='2'><b>Espace</b></font></td>";
            echo "<td bgcolor='#EEEEFF' width='95%'><font size='2'>";
            echo "<a href='?page=espace&amp;pid=".$tab["projet_id"];
            echo "'>Espace projet</a>";
            echo "</td></tr>";
          }
        } else {
          echo "<tr>";
          echo "<td bgcolor='lightblue' width='5%' align='center'>";
          echo "<font size='2'><b>Validation</b></font></td>";
          echo "<td bgcolor='#EEEEFF' width='95%'><font size='2'>";

          /* Partie I: Les groupes */
          $grp = "";
          $grpchoix = 0;
          if($_SESSION["user_level"] == 1) 
            $my_userid = user_id();
          else
            $my_userid = 0;
          $id_gest = array();
          $sql = "select groupes.group_id, groupes_users.user_id, description, titre, email from users, choix, groupes, groupes_users where groupes.owner_id = choix.user_id and groupes_users.group_id = groupes.group_id and users.id = groupes_users.user_id and choix.projet_id = '$voir_id' and etat = 1 order by titre, description asc;";
          $db->query($sql);
          if($db->affected_rows() > 0) {
            /* pour chaque lves ... */
            for($i = 0; $i < $db->affected_rows(); $i ++) {
              $tab_users = $db->fetch_array();
              if($tab_users["titre"] != "$grp") {
                echo "Elves du groupe <b>".$tab_users["titre"]."</b> ";
                /* Si encadrant, alors lien pour valider le projet */
                if($_SESSION["user_level"] >= 5 && user_id() == $tab["id_auteur"]) {
                  echo "(<a href='?page=encadrer&amp;valider=".$tab_users["group_id"]."&projet=".$voir_id."'>";
                  echo "valider pour ce groupe";
                  echo "</a>)";
                }
                echo ":<br />";
                $grp = $tab_users["titre"]; 
              }

              /* Si je suis dans un groupe qui a choisit ce sujet, sans 
                 l'avoir choisi ... */
              if($tab_users["user_id"] == $my_userid) {
                $grpchoix = 1;
              }
              echo "* ";
              echo "<a href='mailto:".$tab_users["email"]."'>";
              echo $tab_users["description"]."</a><br />";
              $id_gest[$tab_users["user_id"]] = 1;
            }
          }

          /* Partie II: Tout les lves (mais on retire ceux traits) */
          $sql = "select id, description, email from users, choix where choix.user_id = users.id and choix.projet_id = '$voir_id' order by description asc;";
          $db->query($sql);
          $printed_autre = 0;
          if($db->affected_rows() > 0) {
            echo "<br />";
            for($i = 0; $i < $db->affected_rows(); $i ++) {
              $tab_users = $db->fetch_array();
              
              /* Si j'ai dj choisi ce sujet, alors je le traite comme tel 
               */
              if($tab_users["id"] == $my_userid) {
                $monchoix = 1;
              }
              if(!array_key_exists($tab_users["id"], $id_gest)) {
                if($printed_autre == 0) {
                  echo "Elves sans groupes:<br />";
                  $printed_autre = 1;
                }
                echo "* <a href='mailto:".$tab_users["email"]."'>";
                echo $tab_users["description"]."</a><br />";
              }
            }
          } else {
            echo "Aucun tudiant intress par ce projet.<br />";
          }
          echo "</font></td>";
          echo "</tr>";

          /* Si utilisateur loggue et il a un level de 1 */
          if($_SESSION["user_level"] == 1) {
            echo "<tr>";
            echo "<td bgcolor='lightblue' width='5%' align='center'>";
            echo "<font size='2'><b>Choix</b></font></td>";
            echo "<td bgcolor='#EEEEFF' width='95%'><font size='2'>";
            if($monchoix == 1) {
              echo "Je suis intress par ce projet: ";
              echo "<a href='?page=projets&amp;subsect=revoquer&amp;id=".$tab["projet_id"]."'>";
              echo "revoquer mon choix</a>";
            } else if ($grpchoix == 1) {
              echo "Ce projet est un choix de mon groupe: ";
              echo "<a href='?page=projets&amp;subsect=choisir&amp;id=".$tab["projet_id"]."'>";
              echo "choix personnel</a> (au cas ou vous vouliez vous dsinscrire du groupe).";
            } else {
              echo "<a href='?page=projets&amp;subsect=choisir&amp;id=".$tab["projet_id"]."'>";
              echo "choisir</a>";
            }
            echo "</font></td>";
            echo "</tr>";
          } /* Fin si la personne peut choisir le sujet */
        } /* Fin projet non valid */
        echo "</table>";
        echo "<br /><br />";
      } /* Fin si Id incorrect */
    }
  }

  function form_ajout($identite, $type = "etudiants") {
    global $db;
?>
<form action="?page=<?echo $type;?>" method="post" name="ajout_form">
<input type="hidden" name="formulaire" value="ajout_form" />
<input type="hidden" name="invalidemail" value="<? echo $s_id; ?>" />
<input type="hidden" name="modifier_login" value="" />
<table border="0">
  <tr>
    <td>Nom:</td>
    <td colspan="2"><input type="text" name="nom" value="<? echo $identite[1]; ?>" /></td>
  </tr>
  <tr>
    <td>Prnom:</td>
    <td colspan="2"><input type="text" name="prenom" value="<? echo $identite[2]; ?>" /></td>
  </tr>
  <tr>
    <td>Email:</td>
    <td><input type="text" name="email" value="<? echo $identite[3]; ?>" /></td>
    <td>
<?
  $sql = "select * from users where email = '".$identite[3]."';";
  $db->query($sql);
  if($db->affected_rows() != 0) {
    echo "<b><font color='red'>Cet email existe dj dans la base de donne.</font></b>";
  }
?>
    </td>
  </tr>
  <tr>
    <td>Mot de passe:</td>
    <td><input type="password" name="password" value="toto" /></td>
    <td>Ce champ est facultatif. Si il est laiss vide, un mot de passe sera aut
omatiquement gnr alatoirement. <b><font color='red'>Un email sera envoy uni
quement si ce champs est modifi.</font></b></td>
  </tr>
  <tr>
    <td>Login:</td>
    <td><input type="text" name="login" value="" /></td>
    <td>Normalement, le login est cr  partir de la premire partie de
l'adresse email entre.<br />On utilisera ce champ uniquement pour ne pas
gnrer le login  partir de cette adresse.</td>
  </tr>
</table>
<br />
<input type="button" name="effacer_button" value="tout effacer" 
       onclick="modifier_login.value='';email.value='';nom.value='';prenom.value
='';login.value='';password.value='';ajout_button.value='ajout'" />
<input type="submit" name="ajout_button" value="ajout" />
</form>
<?


  }
?>
