<?
  /*
   * user_log
   * 
   * Pour quand on se loggue dans le systme.
   * Cette fonction initialise les diffrentes variables de sessions et autre.
   */
  function user_log() {
    global $db, $error_message, $info_message;
    global $page;

    /* Si on veut s'identifier, alors on arrive l: */

    if($_SERVER["REQUEST_METHOD"] == "POST"
    && isset($_POST["formulaire"]) 
    && $_POST["formulaire"] == "ident_form") {

      $str_username = fp2txtsql($_POST["username"]);
      $str_password = md5(fp2txtsql($_POST["password"]));

      /* Verification du login/pass */

      $sql = "select description, level, username from users ";
      $sql.= "where username = '".$str_username."' ";
      $sql.= "and password = '".$str_password."';";

      $db->query($sql);

      if($db->affected_rows()) {
        $tab = $db->fetch_array();
        $_SESSION["user_level"] = $tab["level"]; 
        /* Comme on utilise user_username dans pas mal de query, on le \-ise. */
        $_SESSION["user_username"] = addslashes($tab["username"]);
        $_SESSION["user_description"] = $tab["description"];

        session_register("user_level");
        session_register("user_username");
        session_register("user_description");
        $info_message = "Bienvenue sur le site TER, ".$tab["description"]."!";
      } else {
        $error_message = "Identifiants incorrects.";
      }
    }

    /* Si on a cliqu sur le bouton "partir", alors on se dconnecte */
    if(isset($_REQUEST["page"])
    && $_REQUEST["page"] == "partir"
    && session_is_registered("user_username") == true) {

      session_unregister("user_level");
      session_unregister("user_username");
      session_unregister("user_description");

      $_SESSION["user_level"] = 0;
      $_SESSION["user_username"] = "guest";
      $_SESSION["user_description"] = "";
      $page = "default";
      $info_message = "A bientot !";

      user_group_delog();
    }

    /* 
     * Si on est pas (plus) loggu, alors on redevient visiteur 
     * Ceci est juste une prcaution.
     */
    if(user_is_logged() == false) {
      $_SESSION["user_level"] = 0;
      $_SESSION["user_username"] = "guest";
    }
  }

  /*
   * user_is_login_exists
   *
   * Teste si un login existe deja.
   * renvoit TRUE si c'est le cas, FALSE sinon.
   */
  function user_is_login_exists($login) {
    global $db;

    $sql = "select * from users where username = '".$login."';";
    $db->query($sql);

    if($db->affected_rows() == 1) {
      return(true);
    } else {
      return(false);
    }
  }

  /*
   * user_is_login_free
   *
   * Renvoit l'inverse de user_is_login_exists
   * false si le login est pris, true sinon.
   */
  function user_is_login_free($login) {
    return(user_is_login_exists($login)?false:true);
  }

  /*
   * user_is_logged
   *
   * Renvoit TRUE si l'utilisateur en cours est loggue, FALSE sinon.
   */
  function user_is_logged() {
    if(session_is_registered("user_username") == FALSE
    || $_SESSION["user_username"] == "guest") {
      return false;
    } else {
      return true;
    }
  }

  function make_seed() {
    list($usec, $sec) = explode(' ', microtime());
    srand((float) $sec + ((float) $usec * 100000));
  }

  /*
   * user_generate_login
   *
   * Genere un nom de login aleatoirement
   */
  function user_generate_login() {
    return("siteter".(rand() % 512));
  }

  /*
   * user_generate_password
   *
   * Genere un mot de passe aleatoirement
   */
  function user_generate_password() {
    $car = "abcdefghijklmnopqrstvwxyz0123456789";

    $pass = "";

    for($i = 0; $i < 6; $i ++)
      $pass .= substr("$car", rand(0, strlen($car)), 1);

    return($pass);
  }

  /*
   * user_get_level_description
   *
   * Ressort une chaine de caractere contenant le nom de la qualite de la
   * personne.
   */
  function user_get_level_description() {
    switch($_SESSION["user_level"]) {
      case 0: return("visiteur");
      case 1: return("tudiant");
      case 5: return("encadrant");
      case 10: return("responsable du module");
      default: return("un chevalier Jedi");
    }
  }

  /*
   * user_show
   *
   * Affiche le module utilisateur: identification si l'utilisateur n'est
   * pas loggue, sinon on affiche une boite d'infomation
   */
  function user_show() {
    if(user_is_logged() == false) {
      design_module("Identification", "design_module_ident_form");
    } else {
      if(isset($_SESSION["user_description"])) {
        design_module($_SESSION["user_description"], "design_module_ident");
      }
    }
  }

  /*
   * projet_show
   *
   * Affiche le module recherche projet
   */
  function projet_show() {
    if(isset($_REQUEST["page"]) && $_REQUEST["page"] == "projets") {
      echo "<tr><td>";
      design_module("Recherche", "design_module_recherche");
      echo "</td></tr>";
    }
  }

  /*
   * user_id
   *
   * renvoit l'ID de la personne loggue
   */
  function user_id() {
    global $db;

    if(defined("user_id") == false) {
      $sql = "select id from users where username = '";
      $sql.= $_SESSION["user_username"]."';";
      $db->query($sql);
      $tab = $db->fetch_array();

      if($db->affected_rows() != 1) {
/*        die("Erreur fatale: Vous n'existez pas."); */
        return(-1);
      } else {
        define("user_id", $tab["id"]);
        return(user_id);
      }
    } else { 
      return(user_id);
    }
  }

  /*
   * user_fromhead
   *
   * Ressort de la personne la forme NOM Prenom <email>
   */
  function user_fromhead() {
    global $db;

    if(defined("user_fromhead") == false) {
      $sql = "select description, email from users ";
      $sql.= "where username = '".$_SESSION["user_username"]."';";
      $db->query($sql);
      $tab = $db->fetch_array();

      if($db->affected_rows() != 1) {
/*        die("Erreur fatale: Vous n'existez pas."); */
        return("");
      } else {
        $tmp = $tab["description"] . " &lt;" . $tab["email"] . "&gt;";
        define("user_fromhead", "$tmp");
        return(user_fromhead);
      }
    } else {
      return(user_fromhead);
    }
  }

  /*
   * user_group
   *
   * Initialise si besoin le fait qu'on soit dans un groupe ou non.
   */
  function user_group() {
    global $db;

    if(session_is_registered("user_group_id") == false) { 
      $sql = "select * from groupes_users where user_id = ".user_id().";";
      $db->query($sql);
      if($db->affected_rows() == 1) {
        $tab1 = $db->fetch_array();
        $groupid = $tab1["group_id"];

        $sql = "select titre from groupes where group_id = '$groupid';";

        $db->query($sql);
        $tab2 = $db->fetch_array();

        $_SESSION["user_group_etat"] = $tab1["etat"];
        $_SESSION["user_group_id"] = $groupid;
        $_SESSION["user_group_titre"] = $tab2["titre"];

        $sql = "select id from projets where validgrp = '$groupid';";
        $db->query($sql);
        if($db->affected_rows() == 1) {
          $tab3 = $db->fetch_array();
          $_SESSION["user_group_projet"] = $tab3["id"];
        } else {
          $_SESSION["user_group_projet"] = -1;
        }

        session_register("user_group_etat");
        session_register("user_group_id");
        session_register("user_group_titre");
        session_register("user_group_projet");
      } else {
        user_group_delog();
      } 
    }
  }

  /*
   * user_group_delog
   * 
   * Pour se delogguer du groupe dans lequel on est. (Pour changement de
   * groupe, ou alors quand on se dlog.)
   */
  function user_group_delog() {

    $_SESSION["user_group_etat"] = -1;
    $_SESSION["user_group_id"] = -1;
    $_SESSION["user_group_titre"] = "";
    $_SESSION["user_group_projet"] = -1;

    session_unregister("user_group_etat");
    session_unregister("user_group_id");
    session_unregister("user_group_titre");
    session_unregister("user_group_projet");
  }

  /*
   * user_g_id 
   *
   * Retourne l'ID du groupe dans lequel on se trouve.
   */
  function user_g_id() {
    if(session_is_registered("user_group_id") == false) {
      user_group();
    }
    if(isset($_SESSION["user_group_id"]))
      return($_SESSION["user_group_id"]);
    else
      return(-1);
  }

  /*
   * user_g_etat 
   *
   * Retourne notre tat dans le groupe dans lequel on se trouve, et si besoin
   * lance la fonction user_group().
   */
  function user_g_etat() {
    if(session_is_registered("user_group_etat") == false) {
      user_group();
    }
    if(isset($_SESSION["user_group_etat"]))
      return($_SESSION["user_group_etat"]);
    else
      return(-1);
  }

  /*
   * user_g_titre 
   *
   * Retourne le nom du groupe dans lequel on se trouve, et si besoin
   * lance la fonction user_group().
   */
  function user_g_titre() {
    if(session_is_registered("user_group_titre") == false) {
      user_group();
    }
    if(isset($_SESSION["user_group_titre"]))
      return($_SESSION["user_group_titre"]);
    else
      return("");
  }

  /*
   * user_g_projet
   *
   * Retourne le numero du projet valid pour le groupe, si il existe.
   * Sinon, la valeur par defaut est -1
   */
  function user_g_projet() {
    if(session_is_registered("user_group_projet") == false) {
      user_group();
    } 
    if(isset($_SESSION["user_group_projet"]))
      return($_SESSION["user_group_projet"]);
    else
      return(-1);
  }

  /*
   * user_showdate 
   *
   * Formate une date timestamp en lisible.
   */
  function user_showdate($date) {
    return(date("l dS of F Y h:i:s A", $date));
  }

  /*
   * user_showdateshort
   *
   * Formate uen date courte pour l'utiliser dans la messagerie. 
   */
  function user_showdateshort($date) {
    return(date("d/m/Y h:i", $date));
  }

  /*
   * user_script_valid
   *
   * Vrifie qu'on appelle pas le script directement
   */
  function user_script_valid() {
    if(ereg("index.php$", $_SERVER["SCRIPT_NAME"]) == false)
      die("The script is not valid. (".$_SERVER["SCRIPT_NAME"].")");

    return ;
  }

  /*
   * interface_add_anchor
   *
   * Ajoute une balise pour le module de liens rapides 
   */
  function interface_add_anchor($nom)
  {
    global $anchors_num;
    global $anchors_tab;

    if(!isset($anchors_num))
      $anchors_num = 0;

    $anchors_tab[$anchors_num] = $nom;
    $anchors_num ++;
    echo "<a name='sec".$anchors_num."' />";
  }

  /*
   * init_modules
   *
   * Initialise tout les modules dans un tableau.
   */
  function init_modules()
  {
    global $modules, $db;
    $sql = "select * from modules order by symb;";
    $db->query($sql);
    for($i = 0; $i < $db->affected_rows(); $i ++) {
      $tb = $db->fetch_array();
      $modules[$tb['symb']] = $tb['nom'];
    }

    ksort($modules);      
  }

  function next_creneau($c) {
    sscanf($c, "%04d%02d%02d%02d%02d",
     $d_annee, $d_mois, $d_jour, $d_heure, $d_min);

    if($d_min == 30) {
      return($c + 70);
    } else {
      return($c + 30);
    }
  }
?>
