<?
  require_once("global.inc.php");
  require_once("config.php");

  $scripts_dir = "lib/";

  require_once($scripts_dir . "libsql.php");
  require_once($scripts_dir . "warden.php");
  require_once($scripts_dir . "user.php");

  if(isset($error_level) == TRUE) {
    error_reporting($error_level);
  } else {
    die("No error level defined.");
  }

  $db = new DB_sql($dbhost, $dbbase, $dblogin, $dbpassword);
  $db->connect();

  $sql = "select * from sout_creneaux order by debut asc;";
  $db->query($sql);
  $num = $db->affected_rows();
  if($num == 0) {
    echo "Pas de crneaux rservs pour le moment pour les soutenances.";
    echo "<br /><br />";
  } else {
    $tab_rows = $db->fetch_all_array();
    for($i = 0; $i < $num; $i ++) {
      $tab_row = $tab_rows[$i];
      $u = $tab_row["debut"];
      $v = $tab_row["fin"];

      $sql = "select * from soutenances where debut >= $u and debut < $v order by debut asc;";
      $db->query($sql);
      $num_soutenances = $db->affected_rows();
      $tab_soutenances = $db->fetch_all_array();
      $placees = 0;

      sscanf($u, "%04d%02d%02d%02d%02d",
        $d_annee, $d_mois, $d_jour, $d_heure, $d_min);

      sscanf($v, "%04d%02d%02d%02d%02d",
        $f_annee, $f_mois, $f_jour, $f_heure, $f_min);

      echo "<b>$d_jour/$d_mois/$d_annee</b>, de $d_heure:${d_min}0 ";
      echo " $f_heure:${f_min}0 ";
      echo ":<br />\n";

      do {
        $ecrit = 0;
        sscanf($u, "%04d%02d%02d%02d%02d",
          $d_annee, $d_mois, $d_jour, $d_heure, $d_min);
        $heure = sprintf("%02d:%02d", $d_heure, $d_min);

        echo "* ".$heure.": ";
        if($placees < $num_soutenances)
          if($u == $tab_soutenances[$placees]["debut"]) {
            if($tab_soutenances[$placees]["contenu"] == "") {
              $sql = "select groupes.titre as nom_groupe, ";
              $sql.= "projets.titre as nom_projet, ";
              $sql.= "users.description as nom_encadrant ";
              $sql.= "from projets,users,groupes where validgrp = ";
              $sql.= $tab_soutenances[$placees]["group_id"];
              $sql.= " and projets.id_auteur = users.id ";
              $sql.= "and groupes.group_id = projets.validgrp;";
              $db->query($sql);
              $tab = $db->fetch_array();
              if($db->affected_rows() == 1) {
                echo "<b>" . $tab["nom_projet"] . "</b> encadr par <b>";
                echo $tab["nom_encadrant"] . "</b>";
                echo " (groupe ".$tab["nom_groupe"].")";
              } else {
                echo "groupe " . $tab_soutenances[$placees]["group_id"]; 
              }
              if($tab_soutenances[$placees]["group_id"] != 0) {
                $sql = "select * from groupes_users,users where group_id = ";
                $sql.= $tab_soutenances[$placees]["group_id"];
                $sql.= " and groupes_users.user_id = users.id;";
                $db->query($sql);
                echo "<br />";
                for($z = 0; $z < $db->affected_rows(); $z++) {
                  $tabus = $db->fetch_array();
                  if($z) echo " - ";
                  echo $tabus["description"];
                }
              }
            } else {
              if($tab_soutenances[$placees]["group_id"] != 0) {
                $sql = "select * from groupes where group_id = ";
                $sql.= $tab_soutenances[$placees]["group_id"];
                $db->query($sql);
                $tab = $db->fetch_array();
                $grp_nom = $tab["titre"];
              } else
                $grp_nom = "";

              $ret = preg_split("/:/", $tab_soutenances[$placees]["contenu"]);
              $projid = $ret[0];
              $enca = $ret[1];
              $projn = $ret[2];
              $etud = $ret[3];
              if($projid != "") {
                $sql = "select * from projets where id = '$projid';";
                $db->query($sql);
                $tab = $db->affected_rows();
                echo "Projet: <b>".$tab["titre"]."</b>; ";
              } else if($projn != "") {
                echo "<b>$projn</b>";
              }
              if($projid == "" && $enca != "")
                echo " encadr par <b>$enca</b>";
              if($etud != "") {
                echo "<br />";
                $etud = preg_replace("/\n/", " - ", $etud);
                $etud = preg_replace("/ - $/", "", $etud);
                echo $etud;
              }
              if($tab_soutenances[$placees]["group_id"] != 0) {
                echo " (groupe $grp_nom)";
                $sql = "select * from groupes_users,users where group_id = ";
                $sql.= $tab_soutenances[$placees]["group_id"];
                $sql.= " and groupes_users.user_id = users.id;";
                $db->query($sql);
                echo "<br />";
                for($z = 0; $z < $db->affected_rows(); $z++) {
                  $tabus = $db->fetch_array();
                  if($z) echo " - ";
                  echo $tabus["description"];
                }
              }
            }

            $placees ++;
          }

        echo "<br /><br />\n";

      } while(($u = next_creneau($u)) != $tab_row["fin"]);

      echo "<br />";
    }
  }




?>
